/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of iASLhS4pf1.aml, Tue Feb  4 10:21:43 2020
 *
 * Original Table Header:
 *	   Signature		"SSDT"
 *	   Length			0x00003F9A (16282)
 *	   Revision			0x02
 *	   Checksum			0x46
 *	   OEM ID			"OSY86 "
 *	   OEM Table ID		"HPM"
 *	   OEM Revision		0x00001000 (4096)
 *	   Compiler ID		"INTL"
 *	   Compiler Version 0x20180427 (538444839)
 */
DefinitionBlock ("", "SSDT", 2, "OSY86 ", "HPM", 0x00001000)
{
    External (DTGP, MethodObj)    // 5 Arguments
    External (OSDW, MethodObj)    // 0 Arguments
    External (\_SB.PCI0.I2C1, DeviceObj)
    External (\_SB.PCI0.I2C2, DeviceObj)

    Scope (\_SB.PCI0.I2C1)
    {
        Device (HPM0) // this is the front USB-C port
        {
            Name (_CID, "apple-i2c-hpm0")  // _CID: Compatible ID
            Name (_UID, 0x02)  // _UID: Unique ID
            Name (_ADR, Zero)  // _ADR: Address
            Name (ADR0, 0x3B)  // HPM0_I2C_ADDRESS
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (OSDW ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (LEqual (Arg0, ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                {
                    Store (Package ()
                        {
                            "i2cAddress", 
                            ToBuffer (ADR0), 

                            "i2cSize", 
                            ToBuffer (16), 

                            "addrWidth", 
                            ToBuffer (7), 

                            "dataWidth", 
                            ToBuffer (8), 

                            "sclMode", 
                            ToBuffer (2), 

                            "sclLcnt", 
                            ToBuffer (192), 

                            "sclHcnt", 
                            ToBuffer (101), 

                            "sclPeriod", 
                            ToBuffer (2500), 

                            "sclHz", 
                            ToBuffer (400000), 

                            "sdaHold", 
                            ToBuffer (82), 

                            "sdaSetup", 
                            ToBuffer (Zero), 

                            "ioVoltageSelect", 
                            ToBuffer (3), 

                            "ltrSWMode", 
                            ToBuffer (One), 

                            "ltrEnb", 
                            ToBuffer (Zero), 

                            "powerStrategy", 
                            ToBuffer (0x5442)
                        }, Local0)
                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                    Return (Local0)
                }

                Return (Zero)
            }
        }
    }

    Scope (\_SB.PCI0.I2C2)
    {
        Device (HPM1) // this is the primary TB3 port
        {
            Name (_CID, "apple-i2c-hpm0")  // _CID: Compatible ID
            Name (_UID, 0x02)  // _UID: Unique ID
            Name (_ADR, Zero)  // _ADR: Address
            Name (ADR1, 0x38)  // HPM1_I2C_ADDRESS
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (OSDW ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (LEqual (Arg0, ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                {
                    Store (Package ()
                        {
                            "i2cAddress", 
                            ToBuffer (ADR1), 

                            "i2cSize", 
                            ToBuffer (16), 

                            "addrWidth", 
                            ToBuffer (7), 

                            "dataWidth", 
                            ToBuffer (8), 

                            "sclMode", 
                            ToBuffer (2), 

                            "sclLcnt", 
                            ToBuffer (192), 

                            "sclHcnt", 
                            ToBuffer (101), 

                            "sclPeriod", 
                            ToBuffer (2500), 

                            "sclHz", 
                            ToBuffer (400000), 

                            "sdaHold", 
                            ToBuffer (82), 

                            "sdaSetup", 
                            ToBuffer (Zero), 

                            "ioVoltageSelect", 
                            ToBuffer (3), 

                            "ltrSWMode", 
                            ToBuffer (One), 

                            "ltrEnb", 
                            ToBuffer (Zero), 

                            "powerStrategy", 
                            ToBuffer (0x5442)
                        }, Local0)
                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                    Return (Local0)
                }

                Return (Zero)
            }
        }

        Device (HPM2) // this is the secondary TB3 port
        {
            Name (_CID, "apple-i2c-hpm1")  // _CID: Compatible ID
            Name (_UID, 0x02)  // _UID: Unique ID
            Name (_ADR, Zero)  // _ADR: Address
            Name (ADR2, 0x27)  // HPM1_I2C_ADDRESS
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (OSDW ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (LEqual (Arg0, ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                {
                    Store (Package ()
                        {
                            "i2cAddress", 
                            ToBuffer (ADR2), 

                            "i2cSize", 
                            ToBuffer (16), 

                            "addrWidth", 
                            ToBuffer (7), 

                            "dataWidth", 
                            ToBuffer (8), 

                            "sclMode", 
                            ToBuffer (2), 

                            "sclLcnt", 
                            ToBuffer (192), 

                            "sclHcnt", 
                            ToBuffer (101), 

                            "sclPeriod", 
                            ToBuffer (2500), 

                            "sclHz", 
                            ToBuffer (400000), 

                            "sdaHold", 
                            ToBuffer (82), 

                            "sdaSetup", 
                            ToBuffer (Zero), 

                            "ioVoltageSelect", 
                            ToBuffer (3), 

                            "ltrSWMode", 
                            ToBuffer (One), 

                            "ltrEnb", 
                            ToBuffer (Zero), 

                            "powerStrategy", 
                            ToBuffer (0x5442)
                        }, Local0)
                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                    Return (Local0)
                }

                Return (Zero)
            }
        }
    }
}