/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of iASLhS4pf1.aml, Tue Feb  4 10:21:43 2020
 *
 * Original Table Header:
 *	   Signature		"SSDT"
 *	   Length			0x00003F9A (16282)
 *	   Revision			0x02
 *	   Checksum			0x46
 *	   OEM ID			"OSY86 "
 *	   OEM Table ID		"TbtOnPCH"
 *	   OEM Revision		0x00001000 (4096)
 *	   Compiler ID		"INTL"
 *	   Compiler Version 0x20180427 (538444839)
 */
DefinitionBlock ("", "SSDT", 2, "OSY86 ", "TbtOnPCH", 0x00001000)
{
	External (_SB_.PCI0.GPCB, MethodObj)	// 0 Arguments
	External (_SB_.PCI0.RP05, DeviceObj)
	External (_SB_.PCI0.RP05.PXSX, DeviceObj)
	External (_SB_.PCI0.XHC_, DeviceObj)
	External (_SB_.GGOV, MethodObj)	   // 1 Arguments
	External (_SB_.SGOV, MethodObj)	   // 2 Arguments
	External (DTGP, MethodObj)	  // 5 Arguments
	External (FFTB, MethodObj)	  // Check if Tbt Powered On (1=no, 0=yes)
	External (FP0L, FieldUnitObj) // Thunderbolt power gate level
	External (FPG0, FieldUnitObj) // Thunderbolt power gate register
	External (RPS0, FieldUnitObj) // Root Port
	External (RPT0, FieldUnitObj) // Root Port 
	External (MMRP, MethodObj)	  // Memory Mapped Root Port
	External (MMTB, MethodObj)	  // Memory Mapped Thunderbolt Port
	External (OSDW, MethodObj)	  // 0 Arguments
	External (OSUM, MutexObj)
	External (RMDT.P1__, MethodObj)	   // 1 Arguments
	External (RMDT.P2__, MethodObj)	   // 2 Arguments
	External (RMDT.P3__, MethodObj)	   // 3 Arguments
	External (SOHP, FieldUnitObj)
	External (TBSE, FieldUnitObj)
	External (TNAT, FieldUnitObj)
	External (TWIN, FieldUnitObj)
	
	Scope (\_SB.PCI0.XHC)
	{
		Method (RTPC, 1, Serialized)
		{
			Return (Zero)
		}

		Method (MODU, 0, Serialized)
		{
			If (CondRefOf (\_SB.PCI0.RP05.UPSB.DSB2.XHC2.MODU))
			{
				Return (\_SB.PCI0.RP05.UPSB.DSB2.XHC2.MODU ())
			}
			Else
			{
				Return (One)
			}
		}	 
	}

	Scope (\_SB.PCI0.RP05)
	{	
		Method (DBG1, 1, NotSerialized)
		{
			If (CondRefOf (\RMDT.P1))
			{
				\RMDT.P1 (Arg0)
			}
		}

		Method (DBG2, 2, NotSerialized)
		{
			If (CondRefOf (\RMDT.P2))
			{
				\RMDT.P2 (Arg0, Arg1)
			}
		}

		Method (DBG3, 3, NotSerialized)
		{
			If (CondRefOf (\RMDT.P3))
			{
				\RMDT.P3 (Arg0, Arg1, Arg2)
			}
		}
		
        Scope (\_GPE)
	    {
	        	Method (_E17, 0, NotSerialized)	 // _Exx: Edge-Triggered GPE, xx=0x00-0xFF
		    {
			    \_SB.PCI0.RP05.DBG1 ("_E17 Enter")

			    If (!OSDW ())
			    {
                    If ((\_SB.PCI0.RP05.POC0 == One))
                    {
                        Return (Zero)
                    }

                    If ((\_SB.PCI0.RP05.POCW == One))
                    {
                        Return (Zero)
                    }

                    \_SB.PCI0.RP05.ICMS ()
                    If (\_SB.PCI0.RP05.UPMB)
                    {
                        \_SB.PCI0.RP05.UPMB = Zero
                        Sleep (One)
                    }
                    Else
                    {
                    }

                    Sleep (0x65)
                    \_SB.PCI0.RP05.CMPE ()
                    Sleep (0x07D0)
			    }
			    Else
			    {
				    \_SB.PCI0.RP05.UPSB.AMPE ()
			    }

			    \_SB.PCI0.RP05.DBG1 ("_E17 Exit")
		    }
	    }

		Method (MMIO, 3, NotSerialized)
		{
			Local0 = \_SB.PCI0.GPCB ()
			Local0 += (Arg0 << 0x14)
			Local0 += (Arg1 << 0x0F)
			Local0 += (Arg2 << 0x0C)
			Return (Local0)
		}
		
		Method (MMBA, 2, Serialized)
		{
			Local0 = (\_SB.PCI0.GPCB () + 0x000E4000)
			OperationRegion (MMMM, SystemMemory, Local0, 0x24)
			Field (MMMM, DWordAcc, NoLock, Preserve)
			{
				Offset (0x19), 
				SB19,	8, // SBUS
				Offset (0x20), 
				SB20,	32 // SBUS
			}

			Switch (ToInteger (Arg0))
			{
				Case (One)
				{
					Local1 = Local0
				}
				Case (0x02)
				{
					Local1 = (\_SB.PCI0.GPCB () + (SB19 * 0x00100000))
				}
				Case (0x03)
				{
					Local1 = (\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000))
				}
				Case (0x04)
				{
					Local1 = ((\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000)) + 
						0x8000)
				}
				Case (0x05)
				{
					Local1 = ((\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000)) + 
						0x00010000)
				}
				Case (0x06)
				{
					Local1 = ((\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000)) + 
						0x00020000)
				}
				Case (0x07)
				{
					Local1 = (\_SB.PCI0.GPCB () + ((SB19 + 0x02) * 0x00100000))
				}
				Case (0x08)
				{
					Local1 = ((((SB20 & 0xFFFC) << 0x10) & 0xFFF00000) + 
						0x00039854)
				}
			}

			DBG2 (Arg1, Local1)	 // Arg1 is name of field
			Return (Local1)
		}

		Scope (PXSX)
		{
			Method (_STA, 0, NotSerialized)	 // _STA: Status
			{
				Return (Zero)
			}
		}
	}

    Mutex (TCFG, 0x00)
    Mutex (CTBX, 0x00) // For CTBT()
    Mutex (CRMX, 0x00) // FOR CRMW()
    Mutex (ICMX, 0x00) // FOR ICMS()
    Scope (\_SB.PCI0.RP05)
    {
        Name (EICM, Zero)
		Name (R018, Zero)
		Name (R019, Zero)
		Name (R01A, Zero)
		Name (R01C, Zero)
		Name (R020, Zero) // RP base/limit from UEFI
		Name (R024, Zero) // RP prefetch base/limit from UEFI
		Name (R028, Zero)
		Name (R02C, Zero)
		Name (R118, Zero) // UPSB Pri Bus = RP Sec Bus (UEFI)
		Name (R119, Zero) // UPSB Sec Bus = RP Sec Bus + 1
		Name (R11A, Zero) // UPSB Sub Bus = RP Sub Bus (UEFI)
		Name (R11C, Zero) // UPSB IO base/limit = RP IO base/limit (UEFI)
		Name (R120, Zero) // UPSB mem base/limit = RP mem base/limit (UEFI)
		Name (R124, Zero) // UPSB pre base/limit = RP pre base/limit (UEFI)
		Name (R128, Zero)
		Name (R12C, Zero)
		Name (R218, Zero) // DSB0 Pri Bus = UPSB Sec Bus
		Name (R219, Zero) // DSB0 Sec Bus = UPSB Sec Bus + 1
		Name (R21A, Zero) // DSB0 Sub Bus = UPSB Sub Bus
		Name (R21C, Zero) // DSB0 IO base/limit = UPSB IO base/limit
		Name (R220, Zero) // DSB0 mem base/limit = UPSB mem base/limit
		Name (R224, Zero) // DSB0 pre base/limit = UPSB pre base/limit
		Name (R228, Zero)
		Name (R22C, Zero)
		Name (R318, Zero) // DSB1 Pri Bus = UPSB Sec Bus
		Name (R319, Zero) // DSB1 Sec Bus = UPSB Sec Bus + 2
		Name (R31A, Zero) // DSB1 Sub Bus = no children
		Name (R31C, Zero) // DSB1 disable IO
		Name (R320, Zero) // DSB1 disable mem
		Name (R324, Zero) // DSB1 disable prefetch
		Name (R328, Zero)
		Name (R32C, Zero)
		Name (R418, Zero) // DSB2 Pri Bus = UPSB Sec Bus
		Name (R419, Zero) // DSB2 Sec Bus = UPSB Sec Bus + 3
		Name (R41A, Zero) // DSB2 Sub Bus = no children
		Name (R41C, Zero) // DSB2 disable IO
		Name (R420, Zero) // DSB2 disable mem
		Name (R424, Zero) // DSB2 disable prefetch
		Name (R428, Zero)
		Name (R42C, Zero)
		Name (RVES, Zero) // DSB2 offset 0x564, unknown
		Name (R518, Zero) // DSB4 Pri Bus = UPSB Sec Bus
		Name (R519, Zero) // DSB4 Sec Bus = UPSB Sec Bus + 4
		Name (R51A, Zero) // DSB4 Sub Bus = no children
		Name (R51C, Zero) // DSB4 disable IO
		Name (R520, Zero) // DSB4 disable mem
		Name (R524, Zero) // DSB4 disable prefetch
		Name (R528, Zero)
		Name (R52C, Zero)
		Name (RH10, Zero) // NHI0 BAR0 = DSB0 mem base
		Name (RH14, Zero) // NHI0 BAR1 unused
		Name (POC0, Zero)
        Name (POCW, Zero)
		
		// Root port configuration base
//		OperationRegion (RPSM, SystemMemory, MMRP (RPS0, RPT0), 0x54)
		OperationRegion (RPSM, SystemMemory, MMBA (One, "RP05"), 0x54)
		Field (RPSM, DWordAcc, NoLock, Preserve)
		{
			RPVD,	32, 
			RPR4,	8, 
			Offset (0x18), 
			R_18,	8, 
			R_19,	8, 
			R_1A,	8, 
			Offset (0x1C), 
			R_1C,	16, 
			Offset (0x20), 
			R_20,	32, 
			R_24,	32, 
			R_28,	32, 
			R_2C,	32, 
			Offset (0x50),
				,	5,
			RPTL,	1,
				,	21,
			RPLT,	1,
//			  Offset (0x52), 
//				  ,	  11, 
//			  RPLT,	  1, 
			Offset (0x54)
		}

		// UPSB (up stream port) configuration base
//		OperationRegion (UPSM, SystemMemory, MMTB (RPS0, RPT0), 0x0550)
		OperationRegion (UPSM, SystemMemory, MMBA (0x02, "UPSB"), 0x0550)
		Field (UPSM, DWordAcc, NoLock, Preserve)
		{
			UPVD,	32, 
			UP04,	8, 
			Offset (0x08), 
			CLRD,	32, 
			Offset (0x18), 
			UP18,	8, 
			UP19,	8, 
			UP1A,	8, 
			Offset (0x1C), 
			UP1C,	16, 
			Offset (0x20), 
			UP20,	32, 
			UP24,	32, 
			UP28,	32, 
			UP2C,	32, 
			Offset (0xD2), 
				,	11, 
			UPLT,	1, 
			Offset (0xD4), 
			Offset (0x544), 
			UPMB,	1, 
			Offset (0x548), 
			T2PR,	32, 
			P2TR,	32
		}

		// DSB0 configuration base
		OperationRegion (DNSM, SystemMemory, MMBA (0x03, "DSB0"), 0xD4)
		Field (DNSM, DWordAcc, NoLock, Preserve)
		{
			DPVD,	32, 
			DP04,	8, 
			Offset (0x18), 
			DP18,	8, 
			DP19,	8, 
			DP1A,	8, 
			Offset (0x1C), 
			DP1C,	16, 
			Offset (0x20), 
			DP20,	32, 
			DP24,	32, 
			DP28,	32, 
			DP2C,	32, 
			Offset (0xD2), 
				,	11, 
			DPLT,	1, 
			Offset (0xD4)
		}

		// DSB1 configuration base
		OperationRegion (DS3M, SystemMemory, MMBA (0x04, "DSB1"), 0x40)
		Field (DS3M, DWordAcc, NoLock, Preserve)
		{
			D3VD,	32, 
			D304,	8, 
			Offset (0x18), 
			D318,	8, 
			D319,	8, 
			D31A,	8, 
			Offset (0x1C), 
			D31C,	16, 
			Offset (0x20), 
			D320,	32, 
			D324,	32, 
			D328,	32, 
			D32C,	32
		}

		// DSB2 configuration base
		OperationRegion (DS4M, SystemMemory, MMBA (0x05, "DSB2"), 0x0568)
		Field (DS4M, DWordAcc, NoLock, Preserve)
		{
			D4VD,	32, 
			D404,	8, 
			Offset (0x18), 
			D418,	8, 
			D419,	8, 
			D41A,	8, 
			Offset (0x1C), 
			D41C,	16, 
			Offset (0x20), 
			D420,	32, 
			D424,	32, 
			D428,	32, 
			D42C,	32, 
			Offset (0x564), 
			DVES,	32
		}

		// DSB4 configuration base
		OperationRegion (DS5M, SystemMemory, MMBA (0x06, "DSB4"), 0x40)
		Field (DS5M, DWordAcc, NoLock, Preserve)
		{
			D5VD,	32, 
			D504,	8, 
			Offset (0x18), 
			D518,	8, 
			D519,	8, 
			D51A,	8, 
			Offset (0x1C), 
			D51C,	16, 
			Offset (0x20), 
			D520,	32, 
			D524,	32, 
			D528,	32, 
			D52C,	32
		}

		OperationRegion (NHIM, SystemMemory, MMBA (0x07, "NHI0"), 0x40)
		Field (NHIM, DWordAcc, NoLock, Preserve)
		{
			NH00,	32, 
			NH04,	8, 
			Offset (0x10), 
			NH10,	32, 
			NH14,	32
		}

		OperationRegion (RSTR, SystemMemory, MMBA (0x08, "RSTR"), 0x0100)
		Field (RSTR, DWordAcc, NoLock, Preserve)
		{
			CIOR,	32, 
			Offset (0xB8), 
			ISTA,	32, 
			Offset (0xF0),
//			  Offset (0xEC), 
			ICME,	32
		}

		Method (PINI, 0, NotSerialized)	 // _INI: Initialize
		{
			If (OSDW ())
			{
				DBG3 ("RP", RPVD, R_20)
				DBG1 ("RP05 Initialize")
				Acquire (TCFG, 0xFFFF)
/*
				R018 = R_18 
				R019 = R_19 
				R01A = R_1A 
				R01C = R_1C 
				R020 = R_20
				R024 = R_24
				R028 = R_28 
				R02C = R_2C 
				R118 = RP19 
				R119 = (RP19 + One)
				R11A = RP1A 
				R11C = R01C 
				R120 = R020 
				R124 = R024 
				R128 = R028 
				R12C = R02C 
				R218 = R119 
				R219 = (R119 + One)
				R21A = (R219 + One)
				R21C = R01C 
				R220 = R020 
				R224 = R024 
				R228 = R028 
				R22C = R02C 
				R318 = R119 
				R319 = (R219 + One)
				R31A = (R219 + One)
				R31C = Zero
				R320 = Zero
				R324 = Zero
				R328 = Zero
				R32C = Zero
				R418 = R119 
				R419 = (((RP1A - R219) >> One) + R219) 
				R41A = (((RP1A - R219) >> One) + R219) 
				R41C = Zero
				R420 = Zero
				R424 = Zero
				R428 = Zero
				R42C = Zero
				RVES = Zero
				R518 = R119 
				R519 = (R319 + One)
				R51A = (R319 + One)
				R51C = Zero
				R520 = Zero
				R524 = Zero
				R528 = Zero
				R52C = Zero
				RH10 = ((R220 & 0xFFFC) << 0x10)
				RH14 = (((R220 & 0xFFFC) + 0x04) << 0x10)
*/

				R018 = R_18 // RP Pri Bus
				R019 = R_19 // RP Sec Bus
				R01A = R_1A // RP Sub Bus
				R01C = R_1C // RP IO base/limit from UEFI
				R020 = R_20 // RP base/limit from UEFI
				R024 = R_24 // RP prefetch base/limit from UEFI
				R028 = R_28 
				R02C = R_2C 
				
				R118 = R_19 // UPSB Pri Bus = RP Sec Bus (UEFI)
				R119 = (R_19 + One) // UPSB Sec Bus = RP Sec Bus + 1
				R11A = R_1A // UPSB Sub Bus = RP Sub Bus (UEFI)
				R11C = R01C // UPSB IO base/limit = RP IO base/limit (UEFI)
				R120 = R020 // UPSB mem base/limit = RP mem base/limit (UEFI)
				R124 = R024 // UPSB pre base/limit = RP pre base/limit (UEFI)
				R128 = R028 
				R12C = R02C 
				
				R218 = R119 // DSB0 Pri Bus = UPSB Sec Bus
				R219 = (R119 + One) // DSB0 Sec Bus = UPSB Sec Bus + 1
				R21A = R11A // DSB0 Sub Bus = UPSB Sub Bus
				R21C = R01C // DSB0 IO base/limit = UPSB IO base/limit
				R220 = R020 // DSB0 mem base/limit = UPSB mem base/limit
				R224 = R024 // DSB0 pre base/limit = UPSB pre base/limit
				R228 = R028 
				R22C = R02C 
				
				R318 = R119 // DSB1 Pri Bus = UPSB Sec Bus
				R319 = (R119 + 0x02) // DSB1 Sec Bus = UPSB Sec Bus + 2
				R31A = (R119 + 0x02) // DSB1 Sub Bus = no children
				R31C = Zero // DSB1 disable IO
				R320 = Zero // DSB1 disable mem
				R324 = Zero // DSB1 disable prefetch
				R328 = Zero 
				R32C = Zero 
				
				R418 = R119 // DSB2 Pri Bus = UPSB Sec Bus
				R419 = (R119 + 0x03) // DSB2 Sec Bus = UPSB Sec Bus + 3
				R41A = (R119 + 0x03) // DSB2 Sub Bus = no children
				R41C = Zero // DSB2 disable IO
				R420 = Zero // DSB2 disable mem
				R424 = Zero // DSB2 disable prefetch
				R428 = Zero 
				R42C = Zero 
				
				RVES = Zero // DSB2 offset 0x564, unknown
				
				R518 = R119 // DSB4 Pri Bus = UPSB Sec Bus
				R519 = (R119 + 0x04) // DSB4 Sec Bus = UPSB Sec Bus + 4
				R51A = (R119 + 0x04) // DSB4 Sub Bus = no children
				R51C = Zero // DSB4 disable IO
				R520 = Zero // DSB4 disable mem
				R524 = Zero // DSB4 disable prefetch
				R528 = Zero 
				R52C = Zero 
				
				RH10 = ((R220 & 0xFFFC) << 0x10) // NHI0 BAR0 = DSB0 mem base
                 RH14 = Zero // NHI0 BAR1 unused
//				RH14 = (((R220 & 0xFFFC) + 0x04) << 0x10) // NHI0 BAR1 unused

				Sleep (One)
				ICMB (Zero)
				Release (TCFG)
			}
		}

		Method (ICMB, 1, NotSerialized)
		{
			DBG1 ("ICMBoot")
			Acquire (OSUM, 0xFFFF)
			Local1 = 0x64
			P2TR = 0x0D
			While ((Local1 > Zero))
			{
				Local1 -= One
				Local2 = T2PR /* \_SB_.PCI0.RP05.T2PR */
				If ((Local2 & One))
				{
					Break
				}

				Sleep (0x32)
			}

			P2TR = 0x0C
			Release (OSUM)
			If (CondRefOf (TWIN))
			{
				DBG1 ("Tbt TWIN set to One")
				TWIN = One
			}

			DBG1 ("Tbt Force Power with FPG0")
			SGOV (FPG0, FP0L)
			Sleep (0x02F4)
			
			If ((Arg0 >= 0x03))
			{
				Sleep (0xC8)
				\_SB.PCI0.RP05.POCW = Zero
			}
			
			Local0 = 0x08D0
			Local1 = Timer
			While (Local0)
			{
				If (UPCK ())
				{
					DBG2 ("Up Stream VID/DID =", UPVD)
					Break
				}
				ElseIf ((Local0 == 0x07D0))
				{
					DBG1 ("Slow ICM boot !")
				}

				Sleep (One)
				Local0--
			}

			If (!Local0)
			{
				DBG1 ("Tbt Device no boot !")
			}

			SOHP = Zero
			If (CondRefOf (TNAT))
			{
				DBG1 ("Tbt TNAT set to One")
				TNAT = One
			}

			ICMS ()
			DBG2 ("Configuration delay = ", Concatenate (ToDecimalString (((Timer - Local1) / 0x2710)), " ms"))
//			  DBG1 (Concatenate ("UPSB- Read VID/DID =", \_SB.PCI0.RP05.UPSB.AVND))
//			  DBG1 (Concatenate ("DSB0- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB0.AVND))
//			  DBG1 (Concatenate ("NHI0- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND))
//			  DBG1 (Concatenate ("Global NH00- Read VID/DID =", NH00))
//			  DBG1 (Concatenate ("DSB2- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB2.AVND))
//			  DBG1 (Concatenate ("XHC2- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND))
//			  DBG1 ("ICMB exiting")
			DBG2 ("R_18 =", R_18)
			DBG2 ("R_19 =", R_19)
			DBG2 ("R_1A =", R_1A)
			DBG2 ("R_1C =", R_1C)
			DBG2 ("R_20 =", R_20)
			DBG2 ("R_24 =", R_24)
			DBG2 ("R_28 =", R_28)
			DBG2 ("R_2C =", R_2C)
			
			DBG2 ("UP18 =", UP18)
			DBG2 ("UP19 =", UP19)
			DBG2 ("UP1A =", UP1A)
			DBG2 ("UP1C =", UP1C)
			DBG2 ("UP20 =", UP20)
			DBG2 ("UP24 =", UP24)
			DBG2 ("UP28 =", UP28)
			DBG2 ("UP2C =", UP2C)
			
			DBG2 ("DP18 =", DP18)
			DBG2 ("DP19 =", DP19)
			DBG2 ("DP1A =", DP1A)
			DBG2 ("DP1C =", DP1C)
			DBG2 ("DP20 =", DP20)
			DBG2 ("DP24 =", DP24)
			DBG2 ("DP28 =", DP28)
			DBG2 ("DP2C =", DP2C)
			
			DBG2 ("D418 =", D418)
			DBG2 ("D419 =", D419)
			DBG2 ("D41A =", D41A)
			DBG2 ("D420 =", D420)
			DBG2 ("D424 =", D424)
			DBG2 ("D428 =", D428)
			DBG2 ("D42C =", D42C)
			
			DBG2 ("NH10 =", NH10)
			DBG2 ("NH14 =", NH14)
		}
/*
	val |= REG_FW_STS_ICM_EN_INVERT;
	val |= REG_FW_STS_ICM_EN_CPU;
	
#define REG_FW_STS_ICM_EN_CPU		BIT(2)
#define REG_FW_STS_ICM_EN_INVERT	BIT(1)
*/
		Method (ICMS, 0, NotSerialized)
		{
            Acquire (ICMX, 0xFFFF)
			\_SB.PCI0.RP05.POC0 = One
			DBG2 ("ICME 1", \_SB.PCI0.RP05.ICME)
			If (((\_SB.PCI0.RP05.ICME != 0x800001A6) && (\_SB.PCI0.RP05.ICME != 0x800000A6) &&
                (\_SB.PCI0.RP05.ICME != 0x800001A7)))
			{
				If (\_SB.PCI0.RP05.CNHI ())
				{
					DBG2 ("ICME 2", \_SB.PCI0.RP05.ICME)
					If ((\_SB.PCI0.RP05.ICME != 0xFFFFFFFF))
					{
						Local2 = \_SB.PCI0.RP05.WTLT ()
                         DBG2 ("WTLT returns", Local2)
						DBG2 ("ICME 3", \_SB.PCI0.RP05.ICME)
						If (Local0 = (\_SB.PCI0.RP05.ICME & 0x80000000)) // NVM_AUTH_DONE -- NVM started means we need reset
						{
							\_SB.PCI0.RP05.ICME |= 0x06 // invert EN | enable CPU
							DBG2 ("ICME 4", \_SB.PCI0.RP05.ICME)
							DBG2 ("ISTA 1", \_SB.PCI0.RP05.ISTA)
							Local0 = 0x03E8
							While (((Local1 = (\_SB.PCI0.RP05.ICME & 0x80000000)) == Zero))
							{
								Local0--
								If ((Local0 == Zero))
								{
									Break
								}

								Sleep (One)
							}

							DBG2 ("ICME 5", \_SB.PCI0.RP05.ICME)
							DBG2 ("ISTA 2", \_SB.PCI0.RP05.ISTA)
						}
					}
				}
			}

			\_SB.PCI0.RP05.POC0 = Zero
            Release (ICMX)
		}

        Method (TBTC, 1, Serialized)
        {
            \_SB.PCI0.RP05.POCW = One
            P2TR = Arg0
            Local0 = 0x64
            Local1 = T2PR /* \_SB_.PCI0.RP05.T2PR */
            While (((Local1 & One) == Zero))
            {
                If ((Local1 == 0xFFFFFFFF))
                {
                    Return (Zero)
                }

                Local0--
                If ((Local0 == Zero))
                {
                    Break
                }

                Local1 = T2PR /* \_SB_.PCI0.RP05.T2PR */
                Sleep (0x32)
            }

            P2TR = Zero
        }

		Method (CMPE, 0, Serialized)
		{
			Notify (\_SB.PCI0.RP05, Zero) // Bus Check
		}

		Method (CNHI, 0, Serialized)
		{
			DBG1 ("Configure NHI")
			Local0 = 0x0A
			While (Local0)
			{
				R_18 = R018 /* \_SB_.PCI0.RP05.R018 */
				R_19 = R019 /* \_SB_.PCI0.RP05.R019 */
				R_1A = R01A /* \_SB_.PCI0.RP05.R01A */
				R_1C = R01C /* \_SB_.PCI0.RP05.R01C */
				R_20 = R020 /* \_SB_.PCI0.RP05.R020 */
				R_24 = R024 /* \_SB_.PCI0.RP05.R024 */
				R_28 = R028 /* \_SB_.PCI0.RP05.R028 */
				R_2C = R02C /* \_SB_.PCI0.RP05.R02C */
				RPR4 = 0x07 // this register inits the device
				If ((R020 == R_20))
				{
					Break
				}

				Sleep (One)
				Local0--
			}

			If ((R020 != R_20))
			{
				DBG1 ("Configure NHI RP failed!")
				Return (Zero)
			}

			DBG1 ("Configure UPSB")
			Local0 = 0x0A
			While (Local0)
			{
				UP18 = R118 /* \_SB_.PCI0.RP05.R118 */
				UP19 = R119 /* \_SB_.PCI0.RP05.R119 */
				UP1A = R11A /* \_SB_.PCI0.RP05.R11A */
				UP1C = R11C /* \_SB_.PCI0.RP05.R11C */
				UP20 = R120 /* \_SB_.PCI0.RP05.R120 */
				UP24 = R124 /* \_SB_.PCI0.RP05.R124 */
				UP28 = R128 /* \_SB_.PCI0.RP05.R128 */
				UP2C = R12C /* \_SB_.PCI0.RP05.R12C */
				UP04 = 0x07 // this register inits the device
				If ((R119 == UP19))
				{
					Break
				}

				Sleep (One)
				Local0--
			}

			If ((R119 != UP19))
			{
				DBG1 ("Configure NHI UPSB failed!")
				Return (Zero)
			}

			DBG1 ("Wait for link training")
			If ((WTLT () != One))
			{
				Return (Zero)
			}

			DBG1 ("Configure DSB")
			Local0 = 0x0A
			While (Local0)
			{
				DP18 = R218 /* \_SB_.PCI0.RP05.R218 */
				DP19 = R219 /* \_SB_.PCI0.RP05.R219 */
				DP1A = R21A /* \_SB_.PCI0.RP05.R21A */
				DP1C = R21C /* \_SB_.PCI0.RP05.R21C */
				DP20 = R220 /* \_SB_.PCI0.RP05.R220 */
				DP24 = R224 /* \_SB_.PCI0.RP05.R224 */
				DP28 = R228 /* \_SB_.PCI0.RP05.R228 */
				DP2C = R22C /* \_SB_.PCI0.RP05.R22C */
				DP04 = 0x07 // this register inits the device
				DBG1 ("Configure NHI Dp 0 done")
				D318 = R318 /* \_SB_.PCI0.RP05.R318 */
				D319 = R319 /* \_SB_.PCI0.RP05.R319 */
				D31A = R31A /* \_SB_.PCI0.RP05.R31A */
				D31C = R31C /* \_SB_.PCI0.RP05.R31C */
				D320 = R320 /* \_SB_.PCI0.RP05.R320 */
				D324 = R324 /* \_SB_.PCI0.RP05.R324 */
				D328 = R328 /* \_SB_.PCI0.RP05.R328 */
				D32C = R32C /* \_SB_.PCI0.RP05.R32C */
				D304 = 0x07 // this register inits the device
				DBG1 ("Configure NHI Dp 3 done")
				D418 = R418 /* \_SB_.PCI0.RP05.R418 */
				D419 = R419 /* \_SB_.PCI0.RP05.R419 */
				D41A = R41A /* \_SB_.PCI0.RP05.R41A */
				D41C = R41C /* \_SB_.PCI0.RP05.R41C */
				D420 = R420 /* \_SB_.PCI0.RP05.R420 */
				D424 = R424 /* \_SB_.PCI0.RP05.R424 */
				D428 = R428 /* \_SB_.PCI0.RP05.R428 */
				D42C = R42C /* \_SB_.PCI0.RP05.R42C */
				DVES = RVES /* \_SB_.PCI0.RP05.RVES */
				D404 = 0x07 // this register inits the device
				DBG1 ("Configure NHI Dp 4 done")
				D518 = R518 /* \_SB_.PCI0.RP05.R518 */
				D519 = R519 /* \_SB_.PCI0.RP05.R519 */
				D51A = R51A /* \_SB_.PCI0.RP05.R51A */
				D51C = R51C /* \_SB_.PCI0.RP05.R51C */
				D520 = R520 /* \_SB_.PCI0.RP05.R520 */
				D524 = R524 /* \_SB_.PCI0.RP05.R524 */
				D528 = R528 /* \_SB_.PCI0.RP05.R528 */
				D52C = R52C /* \_SB_.PCI0.RP05.R52C */
				D504 = 0x07 // this register inits the device
				DBG1 ("Configure NHI Dp 5 done")
				If ((R219 == DP19))
				{
					Break
				}

				Sleep (One)
				Local0--
			}

			if ((R519 != D519) || (R419 != D419) || (R319 != D319))
			{
				DBG1 ("One or more DSBs did not initialize")
			}

			If ((R219 != DP19))
			{
				DBG1 ("Configure NHI DPs failed!")
				Return (Zero)
			}

			DBG1 ("Wait for down link")
			If ((WTDL () != One))
			{
				Return (Zero)
			}

			Local0 = 0x64
			While (Local0)
			{
				NH10 = RH10 /* \_SB_.PCI0.RP05.RH10 */
				NH14 = RH14 /* \_SB_.PCI0.RP05.RH14 */
				NH04 = 0x07
				If ((RH10 == NH10))
				{
					Break
				}

				Sleep (One)
				Local0--
			}

			DBG2 ("NHI BAR", NH10)
			If ((RH10 != NH10))
			{
				Return (Zero)
			}

			DBG1 ("Configure NHI all done")
			Return (One)
		}

		Method (UPCK, 0, Serialized)
		{
			If (((UPVD & 0xFF00FFFF) == 0x15008086))
			{
				Return (One)
			}
			Else
			{
				Return (Zero)
			}
		}

		Method (ULTC, 0, Serialized)
		{
			If ((RPLT == Zero))
			{
				If ((UPLT == Zero))
				{
					Return (One)
				}
			}

			Return (Zero)
		}

		Method (WTLT, 0, Serialized)
		{
			Local0 = 0x07D0
			Local1 = Zero
			While (Local0)
			{
				If ((RPR4 == 0x07))
				{
					If (ULTC ())
					{
						If (UPCK ())
						{
							Local1 = One
							Break
						}
					}
				}

				Sleep (One)
				Local0--
			}

			Return (Local1)
		}

		Method (DLTC, 0, Serialized)
		{
			If ((RPLT == Zero))
			{
				If ((UPLT == Zero))
				{
					If ((DPLT == Zero))
					{
						Return (One)
					}
				}
			}

			Return (Zero)
		}

		Method (WTDL, 0, Serialized)
		{
			Local0 = 0x07D0
			Local1 = Zero
			While (Local0)
			{
				If ((RPR4 == 0x07))
				{
					If (DLTC ())
					{
						If (UPCK ())
						{
							Local1 = One
							Break
						}
					}
				}

				Sleep (One)
				Local0--
			}

			Return (Local1)
		}

		Name (IIP3, Zero)
		Name (PRSR, Zero)
		Name (PCIA, One)
		Method (PCEU, 0, Serialized)
		{
			DBG1 ("RP05 PCEU Enter")
			\_SB.PCI0.RP05.PRSR = Zero
			If ((\_SB.PCI0.RP05.PSTA != Zero))
			{
				\_SB.PCI0.RP05.PRSR = One
				\_SB.PCI0.RP05.PSTA = Zero
			}

			If ((\_SB.PCI0.RP05.LDIR == One))
			{
				\_SB.PCI0.RP05.PRSR = One
				\_SB.PCI0.RP05.LDIR = Zero
			}

			DBG1 ("RP05 PCEU Exit")
		}

		Method (PCDA, 0, Serialized)
		{
			DBG1 ("RP05 PCDA Enter")
			If ((\_SB.PCI0.RP05.POFF () != Zero))
			{
				\_SB.PCI0.RP05.PCIA = Zero
				DBG1 ("PCDA RP05- Put upstream bridge into D3")
				\_SB.PCI0.RP05.PSTA = 0x03
				DBG1 ("PCDA RP05- Set link disable on upstream bridge")
				\_SB.PCI0.RP05.LDIR = One
				DBG1 ("PCDA RP05- Wait for link to drop...")
				Local5 = (Timer + 0x00989680)
				While ((Timer <= Local5))
				{
					If ((\_SB.PCI0.RP05.LACR == One))
					{
						If ((\_SB.PCI0.RP05.LACT == Zero))
						{
							DBG1 ("PCDA RP05- No link activity")
							Break
						}
					}
					ElseIf ((\_SB.PCI0.RP05.UPSB.AVND == 0xFFFFFFFF))
					{
						DBG1 ("PCDA RP05- VID/DID is -1")
						Break
					}

					Sleep (0x0A)
				}

				DBG1 ("PCDA RP05- disable GPIO")
				\_SB.PCI0.RP05.GPCI = Zero
				\_SB.PCI0.RP05.UGIO ()
			}
			Else
			{
			}

			\_SB.PCI0.RP05.IIP3 = One
			DBG1 ("RP05 PCDA Exit")
		}

		Method (POFF, 0, Serialized)
		{
			DBG1 ("POFF RP05")
			Return ((!\_SB.PCI0.RP05.RTBL && !\_SB.PCI0.RP05.RUSB))
		}

		Name (GPCI, One)
		Name (GNHI, One)
		Name (GXCI, One)
		Name (RTBL, One)
		Name (RUSB, One)
		Name (CTPD, Zero) 
		Method (CTBT, 0, Serialized)
		{
            Acquire (CTBX, 0xFFFF)
			DBG1 ("CTBT Enter")
//			DBG2 ("CTBT Enter", FFTB (RPS0, RPT0))
//			If (((FFTB (RPS0, RPT0) == Zero) && (\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF)))
			If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
			{
				DBG1 ("CTBT - TBT domain is enabled")
				Local2 = \_SB.PCI0.RP05.UPSB.CRMW (0x3C, Zero, 0x02, 0x04000000, 0x04000000)
				If ((Local2 == Zero))
				{
					DBG1 ("CTBT - Set CP_ACK_POWERDOWN_OVERRIDE")
					\_SB.PCI0.RP05.CTPD = One
				}
			}
			DBG1 ("CTBT Exit")
            Release (CTBX)
		}

		Method (UGIO, 0, Serialized)
		{
			Acquire (TCFG, 0xFFFF)
			If ((\_SB.PCI0.RP05.GPCI == Zero))
			{
				DBG1 ("UGIO - PCI wants off")
			}
			Else
			{
				DBG1 ("UGIO - PCI wants on")
			}

			If ((\_SB.PCI0.RP05.GNHI == Zero))
			{
				DBG1 ("UGIO - NHI wants off")
			}
			Else
			{
				DBG1 ("UGIO - NHI wants on")
			}

			If ((\_SB.PCI0.RP05.GXCI == Zero))
			{
				DBG1 ("UGIO - XHCI wants off")
			}
			Else
			{
				DBG1 ("UGIO - XHCI wants on")
			}

			If ((\_SB.PCI0.RP05.RTBL == Zero))
			{
				DBG1 ("UGIO - TBT allows off")
			}
			Else
			{
				DBG1 ("UGIO - TBT forced on")
			}

			If ((\_SB.PCI0.RP05.RUSB == Zero))
			{
				DBG1 ("UGIO - USB allows off")
			}
			Else
			{
				DBG1 ("UGIO - USB forced on")
			}

			Local0 = (\_SB.PCI0.RP05.GNHI || \_SB.PCI0.RP05.RTBL)
			Local1 = (\_SB.PCI0.RP05.GXCI || \_SB.PCI0.RP05.RUSB)
			If ((\_SB.PCI0.RP05.GPCI != Zero))
			{
				If (((Local0 == Zero) && (Local1 == Zero)))
				{
					Local0 = One
					Local1 = One
				}
			}
			
			If ((Local0 == Zero))
			{
				DBG1 ("UGIO - TBT GPIO should be off")
			}
			Else
			{
				DBG1 ("UGIO - TBT GPIO should be on")
			}

			If ((Local1 == Zero))
			{
				DBG1 ("UGIO - USB GPIO should be off")
			}
			Else
			{
				DBG1 ("UGIO - USB GPIO should be on")
			}
			
			Local2 = Zero
			If (((Local0 != Zero) || (Local1 != Zero)))
			{
//				DBG2 ("UGIO - Make sure TBT & USBC is on. FFTB =", FFTB (RPS0, RPT0))
				DBG1 ("UGIO - Make sure TBT & USBC is on.")
//                If ((FFTB (RPS0, RPT0) == One))  // FFTB retuns One if Tbt is OFF
				If ((GGOV (FPG0) != FP0L))
				{
					DBG1 ("UGIO - Turn on TBT & USBC GPIO")
					SGOV (FPG0, FP0L)
					Local2 = One
					\_SB.PCI0.RP05.CTPD = Zero
				}
                 else
                 {
                     DBG1 ("TBT & USBC already on.")
                 }
			}
/*
			Local2 = Zero
			If ((Local0 != Zero))
			{
				If (Zero)
				{
					Local2 = One
					\_SB.PCI0.RP05.CTPD = Zero
				}
			}

			If ((Local1 != Zero))
			{
				If (Zero)
				{
					Local2 = One
				}
			}
*/
			If ((Local2 != Zero))
			{
				Sleep (0x01F4)
			}
			
			Local3 = Zero
			If (((Local0 == Zero) && (Local1 == Zero)))
			{
//				DBG2 ("UGIO - Make sure TBT & USBC is off. FFTB = ", FFTB (RPS0, RPT0))
				DBG1 ("UGIO - Make sure TBT & USBC is off.")
//				If ((FFTB (RPS0, RPT0) == Zero))  // FFTB retuns Zero if Tbt is ON
				If ((GGOV (FPG0) == FP0L))
				{
					DBG1 ("UGIO - Make sure TBT & USBC is off")
					\_SB.PCI0.RP05.CTBT ()
					If ((\_SB.PCI0.RP05.CTPD != Zero))
					{
						DBG1 ("UGIO - Turn off TBT & USBC GPIO")
						SGOV (FPG0, !FP0L)
						Local3 = One
					}
					Else
					{
						DBG1 ("UGIO - CP_ACK_POWERDOWN_OVERRIDE not configured, cannot turn off TBT GPIO")
					}
				}
                else
                {
                     DBG1 ("TBT & USBC already off.")
                }
			}

/*
			Local3 = Zero
			If ((Local0 == Zero))
			{
				If (Zero)
				{
					\_SB.PCI0.RP05.CTBT ()
					If ((\_SB.PCI0.RP05.CTPD != Zero))
					{
						Local3 = One
					}
				}
			}

			If ((Local1 == Zero))
			{
				If (Zero)
				{
					Local3 = One
				}
			}
*/
			If ((Local3 != Zero))
			{
				Sleep (0x64)
			}

            DBG1 ("UGIO Exit")
            
			Release (TCFG)
			Return (Local2)
		}

		Method (_PS0, 0, Serialized)  // _PS0: Power State 0
		{
			If (OSDW ())
			{
				DBG1 ("RP05 _PS0")
				PCEU ()
			}
		}

		Method (_PS3, 0, Serialized)  // _PS3: Power State 3
		{
			If (OSDW ())
			{
				DBG1 ("RP05 _PS3")
				If ((\_SB.PCI0.RP05.POFF () != Zero))
				{
					\_SB.PCI0.RP05.CTBT ()
				}

				PCDA ()
			}
		}

		Method (UTLK, 2, Serialized)
		{
			Local0 = Zero
			If (Zero)
			{
				\_SB.PCI0.RP05.PSTA = Zero
				While (One)
				{
					If ((\_SB.PCI0.RP05.LDIR == One))
					{
						\_SB.PCI0.RP05.LDIR = Zero
					}

					Local1 = Zero
					Local2 = (Timer + 0x00989680)
					While ((Timer <= Local2))
					{
						If ((\_SB.PCI0.RP05.LACR == Zero))
						{
							If ((\_SB.PCI0.RP05.LTRN != One))
							{
								Break
							}
						}
						ElseIf (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)))
						{
							Break
						}

						Sleep (0x0A)
					}

					Sleep (Arg1)
					While ((Timer <= Local2))
					{
						If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
						{
							Local1 = One
							Break
						}

						Sleep (0x0A)
					}

					If ((Local1 == One))
					{
						\_SB.PCI0.RP05.MABT = One
						Break
					}

					If ((Local0 == 0x04))
					{
						Break
					}

					Local0++
					Sleep (0x03E8)
				}
			}
		}

		OperationRegion (A1E0, PCI_Config, Zero, 0x40)
		Field (A1E0, ByteAcc, NoLock, Preserve)
		{
			AVND,	32, 
			BMIE,	3, 
			Offset (0x18), 
			PRIB,	8, 
			SECB,	8, 
			SUBB,	8, 
			Offset (0x1E), 
				,	13, 
			MABT,	1
		}

		OperationRegion (HD94, PCI_Config, 0x0D94, 0x08)
		Field (HD94, ByteAcc, NoLock, Preserve)
		{
			Offset (0x04), 
			PLEQ,	1, 
			Offset (0x08)
		}

		OperationRegion (A1E1, PCI_Config, 0x40, 0x40)
		Field (A1E1, ByteAcc, NoLock, Preserve)
		{
			Offset (0x01), 
			Offset (0x02), 
			Offset (0x04), 
			Offset (0x08), 
			Offset (0x0A), 
				,	5, 
			TPEN,	1, 
			Offset (0x0C), 
			SSPD,	4, 
				,	16, 
			LACR,	1, 
			Offset (0x10), 
			ASPM,	2,
				,	2, 
			LDIR,	1, 
			LRTN,	1, 
			Offset (0x12), 
			CSPD,	4, 
			CWDT,	6, 
				,	1, 
			LTRN,	1, 
				,	1, 
			LACT,	1, 
			Offset (0x14), 
			Offset (0x30), 
			TSPD,	4
		}

		OperationRegion (A1E2, PCI_Config, 0xA0, 0x08)
		Field (A1E2, ByteAcc, NoLock, Preserve)
		{
			Offset (0x01), 
			Offset (0x02), 
			Offset (0x04), 
			PSTA,	2
		}

		OperationRegion (DMIH, PCI_Config, 0x0324, One)
		Field (DMIH, ByteAcc, NoLock, Preserve)
		{
				,	3, 
			LEDN,	1
		}

		OperationRegion (A1E3, PCI_Config, 0x0200, 0x20)
		Field (A1E3, ByteAcc, NoLock, Preserve)
		{
			Offset (0x14), 
			Offset (0x16), 
			PSTS,	4
		}

		Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
		{
			Return (Zero)
		}

		Device (UPSB)
		{
			Name (_ADR, Zero)  // _ADR: Address
			OperationRegion (A1E0, PCI_Config, Zero, 0x40)
			Field (A1E0, ByteAcc, NoLock, Preserve)
			{
				AVND,	32, 
				BMIE,	3, 
				Offset (0x18), 
				PRIB,	8, 
				SECB,	8, 
				SUBB,	8, 
				Offset (0x1E), 
					,	13, 
				MABT,	1
			}

			OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
			Field (A1E1, ByteAcc, NoLock, Preserve)
			{
				Offset (0x01), 
				Offset (0x02), 
				Offset (0x04), 
				Offset (0x08), 
				Offset (0x0A), 
					,	5, 
				TPEN,	1, 
				Offset (0x0C), 
				SSPD,	4, 
					,	16, 
				LACR,	1, 
				Offset (0x10), 
					,	4, 
				LDIR,	1, 
				LRTN,	1, 
				Offset (0x12), 
				CSPD,	4, 
				CWDT,	6, 
					,	1, 
				LTRN,	1, 
					,	1, 
				LACT,	1, 
				Offset (0x14), 
				Offset (0x30), 
				TSPD,	4
			}

			OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
			Field (A1E2, ByteAcc, NoLock, Preserve)
			{
				Offset (0x01), 
				Offset (0x02), 
				Offset (0x04), 
				PSTA,	2
			}

			Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
			{
				Return (SECB) /* \_SB_.PCI0.RP05.UPSB.SECB */
			}

			Method (_STA, 0, NotSerialized)	 // _STA: Status
			{
				Return (0x0F)
			}

			Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
			{
				Return (Zero)
			}

			Method (PCED, 0, Serialized)
			{
				DBG1 ("UPSB PCED Enter")
				\_SB.PCI0.RP05.GPCI = One
				If ((\_SB.PCI0.RP05.UGIO () != Zero))
				{
					DBG1 ("PCED - GPIOs changed, restored = true")
					\_SB.PCI0.RP05.PRSR = One
				}

				Local0 = Zero
				Local1 = Zero
				If ((Local1 == Zero))
				{
					If ((\_SB.PCI0.RP05.IIP3 != Zero))
					{
						\_SB.PCI0.RP05.PRSR = One
						Local0 = One
						DBG1 ("PCED UPSB- Set link disable on upstream bridge")
						\_SB.PCI0.RP05.LDIR = One
					}
				}

				LWRT = Zero
				LRRT = Zero
				LPRT = Zero
				Local3 = Zero
				While ((Local3 == Zero))
				{
					Local4 = Zero
					DBG1 ("PCED UPSB- restored flag, THUNDERBOLT_PCI_LINK_MGMT_DEVICE.PRSR")
					DBG1 (\_SB.PCI0.RP05.PRSR)
					Local5 = (Timer + 0x00989680)
					If ((\_SB.PCI0.RP05.PRSR != Zero))
					{
						Sleep (0x1E)
						If (((Local0 != Zero) || (Local1 != Zero)))
						{
							\_SB.PCI0.RP05.TSPD = One
							If ((Local1 != Zero)){}
							ElseIf ((Local0 != Zero))
							{
								\_SB.PCI0.RP05.LDIR = Zero
							}

							DBG1 ("PCED UPSB- Wait for link training...")
							While ((Timer <= Local5))
							{
								If ((\_SB.PCI0.RP05.LACR == Zero))
								{
									If ((\_SB.PCI0.RP05.LTRN != One))
									{
										DBG1 ("PCED UPSB- GENSTEP WA - Link training cleared")
										Break
									}
								}
								ElseIf (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)))
								{
									DBG1 ("PCED UPSB- GENSTEP WA - Link training cleared and link is active")
									Break
								}

								Sleep (0x0A)
							}

							Sleep (0x78)
							DBG1 ("PCED UPSB- PEG WA - Wait for config space...")
							While ((Timer <= Local5))
							{
								If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
								{
									DBG2 ("PCED UPSB- PEG WA - Read VID/DID =", \_SB.PCI0.RP05.UPSB.AVND)
									Break
								}

								Sleep (0x0A)
							}

							\_SB.PCI0.RP05.TSPD = 0x03
							\_SB.PCI0.RP05.LRTN = One
						}
	
						DBG1 ("PCED UPSB- Wait for downstream bridge to appear...")
						Local5 = (Timer + 0x00989680)
						While ((Timer <= Local5))
						{
							If ((\_SB.PCI0.RP05.LACR == Zero))
							{
								If ((\_SB.PCI0.RP05.LTRN != One))
								{
									DBG1 ("PCED UPSB- Link training cleared")
									Break
								}
							}
							ElseIf (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)))
							{
								DBG1 ("PCED UPSB- Link training cleared and link is active")
								Break
							}

							Sleep (0x0A)
						}

						Sleep (0xFA)
					}

					DBG1 ("PCED UPSB- Wait for config space...")
					While ((Timer <= Local5))
					{
						If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
						{
							Local4 = One
							Break
						}

						Sleep (0x0A)
					}
					
					DBG2 ("PCED UPSB- Read VID/DID =", \_SB.PCI0.RP05.UPSB.AVND)
					If ((\_SB.PCI0.RP05.CSPD != 0x03))
					{
						If ((\_SB.PCI0.RP05.SSPD == 0x03))
						{
							If ((\_SB.PCI0.RP05.UPSB.SSPD == 0x03))
							{
								If ((\_SB.PCI0.RP05.TSPD != 0x03))
								{
									\_SB.PCI0.RP05.TSPD = 0x03
								}

								If ((\_SB.PCI0.RP05.UPSB.TSPD != 0x03))
								{
									\_SB.PCI0.RP05.UPSB.TSPD = 0x03
								}

								\_SB.PCI0.RP05.LRTN = One
								Local2 = (Timer + 0x00989680)
								While ((Timer <= Local2))
								{
									If ((\_SB.PCI0.RP05.LACR == Zero))
									{
										If (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF)))
										{
											\_SB.PCI0.RP05.PCIA = One
											Local1 = One
											Break
										}
									}
									ElseIf ((((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)) && 
										(\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF)))
									{
										\_SB.PCI0.RP05.PCIA = One
										Local1 = One
										Break
									}

									Sleep (0x0A)
								}
							}
							Else
							{
								\_SB.PCI0.RP05.PCIA = One
							}
						}
						Else
						{
							\_SB.PCI0.RP05.PCIA = One
						}
					}
					Else
					{
						\_SB.PCI0.RP05.PCIA = One
					}

					Local5 = ((LWRT < LWMR) && (\_SB.PCI0.RP05.PRSR != Zero))
					Local6 = ((\_SB.PCI0.RP05.CWDT != 0x04) && ((TFLG & One) == Zero))
					Local7 = ((Local4 == Zero) && ((TFLG & 0x02) == Zero))
					If (((Local6 || Local7) && Local5))
					{
						Local1 = Zero
						If ((Local4 != Zero))
						{
							LRRT += One
							\_SB.PCI0.RP05.UPSB.CRMW (0x0771, Zero, 0x02, 0x0200, 0xFFFFFFFF)
						}

						Local0 = One
						\_SB.PCI0.RP05.LDIR = One
						\_SB.PCI0.RP05.PCIA = Zero
						 Sleep (0x64)
						LWRT += One
					}
					Else
					{
						Local3 = One
					}
				}
				\_SB.PCI0.RP05.PRSR = Zero
				\_SB.PCI0.RP05.IIP3 = Zero
				DBG1 ("UPSB PCED Exit")
			}

			Method (AMPE, 0, Serialized)
			{
				DBG1 ("UPSB AMPE")
				Notify (\_SB.PCI0.RP05.UPSB.DSB0.NHI0, Zero) // Bus Check
			}

			Method (UMPE, 0, Serialized)
			{
				DBG1 ("UPSB UMPE")
				Notify (\_SB.PCI0.RP05.UPSB.DSB2.XHC2, Zero) // Bus Check
				Notify (\_SB.PCI0.XHC, Zero) // Bus Check
			}

			Name (MDUV, One)
			Method (MUST, 1, Serialized)
			{
				DBG2 ("MUST UPSB with arg", Arg0)
				If (OSDW ())
				{
					If ((MDUV != Arg0))
					{
						MDUV = Arg0
						UMPE ()
					}
				}

				Return (Zero)
			}

			Name (TFLG, Zero)
			Name (LWMR, 0x0A)
			Name (LWRT, Zero)
			Name (LRRT, Zero)
			Name (LPRT, Zero)
			Method (SLMR, 1, Serialized)
			{
				LWMR = Arg0
			}

			Method (SFLG, 1, Serialized)
			{
				TFLG = Arg0
			}

			Method (_PS0, 0, Serialized)  // _PS0: Power State 0
			{
				DBG1 ("UPSB _PS0")
				If (OSDW ())
				{
					PCED ()
                    \_SB.PCI0.RP05.UPSB.CRMW (0x0150, Zero, 0x02, 0x04000000, 0x04000000)
                    \_SB.PCI0.RP05.UPSB.CRMW (0x0250, Zero, 0x02, 0x04000000, 0x04000000)
				}
			}

			Method (_PS3, 0, Serialized)  // _PS3: Power State 3
			{
				DBG1 ("UPSB _PS3 - No Op")
				If (!OSDW ())
				{
					If ((\_SB.PCI0.RP05.UPCK () == Zero))
					{
						\_SB.PCI0.RP05.UTLK (One, 0x03E8)
					}

					\_SB.PCI0.RP05.TBTC (0x05)
				}
			}

			OperationRegion (H548, PCI_Config, 0x0548, 0x20)
			Field (H548, DWordAcc, Lock, Preserve)
			{
				T2PC,	32, 
				PC2T,	32
			}

			OperationRegion (H530, PCI_Config, 0x0530, 0x0C)
			Field (H530, DWordAcc, Lock, Preserve)
			{
				DWIX,	13, 
				PORT,	6, 
				SPCE,	2, 
				CMD0,	1, 
				CMD1,	1, 
				CMD2,	1, 
					,	6, 
				PROG,	1, 
				TMOT,	1, 
				WDAT,	32, 
				RDAT,	32
			}

			Method (CIOW, 4, Serialized)
			{
				WDAT = Arg3
				DWIX = Arg0
				PORT = Arg1
				SPCE = Arg2
				CMD0 = One
				CMD1 = Zero
				CMD2 = Zero
				TMOT = Zero
				PROG = One
				Local1 = One
				Local0 = 0x2710
				While ((Zero < Local0))
				{
					If ((PROG == Zero))
					{
						Local1 = Zero
						Break
					}

					Stall (0x19)
					Local0--
				}

				If ((Local1 == Zero))
				{
					Local1 = TMOT /* \_SB_.PCI0.RP05.UPSB.TMOT */
				}
				Else
				{
				}

				Return (Local1)
			}

			Method (CIOR, 3, Serialized)
			{
				RDAT = Zero
				DWIX = Arg0
				PORT = Arg1
				SPCE = Arg2
				CMD0 = Zero
				CMD1 = Zero
				CMD2 = Zero
				TMOT = Zero
				PROG = One
				Local1 = One
				Local0 = 0x2710
				While ((Zero < Local0))
				{
					If ((PROG == Zero))
					{
						Local1 = Zero
						Break
					}

					Stall (0x19)
					Local0--
				}

				If ((Local1 == Zero))
				{
					Local1 = TMOT /* \_SB_.PCI0.RP05.UPSB.TMOT */
				}
				Else
				{
				}

				If ((Local1 == Zero))
				{
					Return (Package (0x02)
					{
						Zero, 
						RDAT
					})
				}
				Else
				{
					Return (Package (0x02)
					{
						One, 
						RDAT
					})
				}
			}

			Method (CRMW, 5, Serialized)
			{
                 Acquire (CRMX, 0xFFFF)
				Local1 = One
				DBG1 ("CRMW Enter")
				If (((GGOV (FPG0) == FP0L) && (\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF)))
//				If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
				{
					Local3 = Zero
					While ((Local3 <= 0x04))
					{
						Local2 = CIOR (Arg0, Arg1, Arg2)
						If ((DerefOf (Local2 [Zero]) == Zero))
						{
							Local2 = DerefOf (Local2 [One])
							DBG2 ("CRMW Read Value 1", Local2)
							Local2 &= ~Arg4
							Local2 |= Arg3
							DBG2 ("CRMW Write Value 1", Local2)
							Local2 = CIOW (Arg0, Arg1, Arg2, Local2)
							If ((Local2 == Zero))
							{
								Local2 = CIOR (Arg0, Arg1, Arg2)
								If ((DerefOf (Local2 [Zero]) == Zero))
								{
									Local2 = DerefOf (Local2 [One])
									DBG2 ("CRMW Read Value 2", Local2)
									Local2 &= Arg4
									If ((Local2 == Arg3))
									{
										DBG1 ("CRMW Success")
										Local1 = Zero
										Break
									}
								}
							}
						}

						Local3++
						Sleep (0x64)
					}
				}
                DBG1 ("CRMW Exit")
                 Release (CRMX)
				Return (Local1)
			}

			Method (LSTX, 2, Serialized)
			{
				If ((T2PC != 0xFFFFFFFF))
				{
					Local0 = Zero
					If (((T2PC & One) && One))
					{
						Local0 = One
					}

					If ((Local0 == Zero))
					{
						Local1 = 0x2710
						While ((Zero < Local1))
						{
							If ((T2PC == Zero))
							{
								Break
							}

							Stall (0x19)
							Local1--
						}

						If ((Zero == Local1))
						{
							Local0 = One
						}
					}

					If ((Local0 == Zero))
					{
						Local1 = One
						Local1 |= 0x14
						Local1 |= (Arg0 << 0x08)
						Local1 |= (Arg1 << 0x0C)
						Local1 |= 0x00400000
						PC2T = Local1
					}

					If ((Local0 == Zero))
					{
						Local1 = 0x2710
						While ((Zero < Local1))
						{
							If ((T2PC == 0x15))
							{
								Break
							}

							Stall (0x19)
							Local1--
						}

						If ((Zero == Local1))
						{
							Local0 = One
						}
					}

					Sleep (0x0A)
					PC2T = Zero
				}
			}

			Device (DSB0)
			{
				Name (_ADR, Zero)  // _ADR: Address
				OperationRegion (A1E0, PCI_Config, Zero, 0x40)
				Field (A1E0, ByteAcc, NoLock, Preserve)
				{
					AVND,	32, 
					BMIE,	3, 
					Offset (0x18), 
					PRIB,	8, 
					SECB,	8, 
					SUBB,	8, 
					Offset (0x1E), 
						,	13, 
					MABT,	1
				}

				OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
				Field (A1E1, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					Offset (0x08), 
					Offset (0x0A), 
						,	5, 
					TPEN,	1, 
					Offset (0x0C), 
					SSPD,	4, 
						,	16, 
					LACR,	1, 
					Offset (0x10), 
						,	4, 
					LDIR,	1, 
					LRTN,	1, 
					Offset (0x12), 
					CSPD,	4, 
					CWDT,	6, 
						,	1, 
					LTRN,	1, 
						,	1, 
					LACT,	1, 
					Offset (0x14), 
					Offset (0x30), 
					TSPD,	4
				}

				OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
				Field (A1E2, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					PSTA,	2
				}

				Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
				{
					Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB0.SECB */
				}

				Method (_STA, 0, NotSerialized)	 // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
				{
					Return (Zero)
				}

				Name (IIP3, Zero)
				Name (PRSR, Zero)
				Name (PCIA, One)
				Method (PCEU, 0, Serialized)
				{
					DBG1 ("DSB0 PCEU Enter: Put upstream bridge back to D0")
					\_SB.PCI0.RP05.UPSB.DSB0.PRSR = Zero
					If ((\_SB.PCI0.RP05.UPSB.DSB0.PSTA != Zero))
					{
						DBG1 ("PCEU DSB0- exit D0, restored = true")
						\_SB.PCI0.RP05.UPSB.DSB0.PRSR = One
						\_SB.PCI0.RP05.UPSB.DSB0.PSTA = Zero
					}

					If ((\_SB.PCI0.RP05.UPSB.DSB0.LDIR == One))
					{
						DBG1 ("PCEU DSB0- Clear link disable on upstream bridge")
						DBG1 ("PCEU DSB0- clear link disable, restored = true")
						\_SB.PCI0.RP05.UPSB.DSB0.PRSR = One
						\_SB.PCI0.RP05.UPSB.DSB0.LDIR = Zero
					}
					DBG1 ("DSB0 PCEU Exit")
				}

				Method (PCDA, 0, Serialized)
				{
					DBG1 ("DSB0 PCDA")
					If ((\_SB.PCI0.RP05.UPSB.DSB0.POFF () != Zero))
					{
						\_SB.PCI0.RP05.UPSB.DSB0.PCIA = Zero
						DBG1 ("PCDA DSB0- Put upstream bridge into D3")
						\_SB.PCI0.RP05.UPSB.DSB0.PSTA = 0x03
						DBG1 ("PCDA DSB0- Set link disable on upstream bridge")
						\_SB.PCI0.RP05.UPSB.DSB0.LDIR = One
						DBG1 ("PCDA DSB0- Wait for link to drop...")
						Local5 = (Timer + 0x00989680)
						While ((Timer <= Local5))
						{
							If ((\_SB.PCI0.RP05.UPSB.DSB0.LACR == One))
							{
								If ((\_SB.PCI0.RP05.UPSB.DSB0.LACT == Zero))
								{
									DBG1 ("PCDA DSB0- No link activity")
									Break
								}
							}
							ElseIf ((\_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND == 0xFFFFFFFF))
							{
								DBG1 ("PCDA DSB0 - NHI0 not present")
								Break
							}

							Sleep (0x0A)
						}

						DBG1 ("PCDA DSB0- disable GPIO")
						\_SB.PCI0.RP05.GNHI = Zero
						\_SB.PCI0.RP05.UGIO ()
					}
					Else
					{
						DBG1 ("PCDA DSB0- Not disabling")
					}

					\_SB.PCI0.RP05.UPSB.DSB0.IIP3 = One
				}

				Method (POFF, 0, Serialized)
				{
					 DBG1 ("POFF DSB0")
					 Return (!\_SB.PCI0.RP05.RTBL)
				}

				Method (_PS0, 0, Serialized)  // _PS0: Power State 0
				{
					DBG1 ("_PS0 DSB0")
					If (OSDW ())
					{
						PCEU ()
					}
				}

				Method (_PS3, 0, Serialized)  // _PS3: Power State 3
				{
					DBG1 ("_PS3 DSB0")
					If (OSDW ())
					{
						PCDA ()
					}
				}

				Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
				{
					If (OSDW ())
					{
						If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
						{
							Local0 = Package (0x02)
								{
									"PCIHotplugCapable", 
									Zero
								}
							DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
							Return (Local0)
						}
					}

					Return (Zero)
				}

				Device (NHI0)
				{
					Name (_ADR, Zero)  // _ADR: Address
					Name (_STR, Unicode ("Thunderbolt"))  // _STR: Description String
					Method (PCED, 0, Serialized)
					{
						DBG1 ("NHI0 PCED Enter")
						\_SB.PCI0.RP05.GNHI = One
						If ((\_SB.PCI0.RP05.UGIO () != Zero))
						{
							DBG1 ("PCED - GPIOs changed, restored = true")
							\_SB.PCI0.RP05.UPSB.DSB0.PRSR = One
						}

						Local0 = Zero
						Local1 = Zero
						Local3 = Zero
						While ((Local3 == Zero))
						{
							Local4 = Zero
							DBG1 ("PCED NHI0- restored flag, THUNDERBOLT_PCI_LINK_MGMT_DEVICE.PRSR")
							DBG1 (\_SB.PCI0.RP05.UPSB.DSB0.PRSR)
							Local5 = (Timer + 0x00989680)
							If ((\_SB.PCI0.RP05.UPSB.DSB0.PRSR != Zero))
							{
								DBG1 ("PCED NHI0- Wait for link training...")
								Local5 = (Timer + 0x00989680)
								While ((Timer <= Local5))
								{
									If ((\_SB.PCI0.RP05.UPSB.DSB0.LACR == Zero))
									{
										If ((\_SB.PCI0.RP05.UPSB.DSB0.LTRN != One))
										{
											DBG1 ("PCED NHI0- Link training cleared")
											Break
										}
									}
									ElseIf (((\_SB.PCI0.RP05.UPSB.DSB0.LTRN != One) && (\_SB.PCI0.RP05.UPSB.DSB0.LACT == One)))
									{
										DBG1 ("PCED NHI0- Link training cleared and link is active")
										Break
									}

									Sleep (0x0A)
								}

								Sleep (0x96)
							}

							DBG1 ("PCED NHI0- Wait for config space...")
							While ((Timer <= Local5))
							{
								If ((\_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND != 0xFFFFFFFF))
								{
									Local4 = One
									\_SB.PCI0.RP05.UPSB.DSB0.PCIA = One
									Break
								}

								Sleep (0x0A)
							}
							
							DBG2 ("PCED NHI0- Read VID/DID = ", \_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND)
							Local3 = One
						}
						\_SB.PCI0.RP05.UPSB.DSB0.PRSR = Zero
						\_SB.PCI0.RP05.UPSB.DSB0.IIP3 = Zero
					}

					Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
					{
						Return (Zero)
					}

					OperationRegion (A1E0, PCI_Config, Zero, 0x40)
					Field (A1E0, ByteAcc, NoLock, Preserve)
					{
						AVND,	32, 
						BMIE,	3, 
						Offset (0x18), 
						PRIB,	8, 
						SECB,	8, 
						SUBB,	8, 
						Offset (0x1E), 
							,	13, 
						MABT,	1
					}

					Method (RTPC, 1, Serialized)
					{
						DBG2 ("RTPC NHI0 called with arg: ", Arg0)
						If (OSDW ())
						{
							If ((Arg0 <= One))
							{
								\_SB.PCI0.RP05.RTBL = Arg0
							}
						}

						Return (Zero)
					}

					Method (MUST, 1, Serialized)
					{
						DBG1 ("MUST NHI0")
						Return (\_SB.PCI0.RP05.UPSB.MUST (Arg0))
					}

					Method (_PS0, 0, Serialized)  // _PS0: Power State 0
					{
						DBG2 ("_PS0 NHI0 -> ICME = ", \_SB.PCI0.RP05.ICME)
                         DBG1 ("If ICME bits [2],[1] != 1,1 then ICMS?")
						If (OSDW ())
						{
							PCED ()
							\_SB.PCI0.RP05.CTBT ()
						}
					}

					Method (_PS3, 0, Serialized)  // _PS3: Power State 3
					{
						DBG1 ("_PS3 NHI0, Nothing to do!")
					}

					Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
					{
						If (OSDW ())
						{
							Local0 = Package (0x03)
								{
									"power-save", 
									One, 
									Buffer (One)
									{
										 0x00											  // .
									}
								}
							DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
							Return (Local0)
						}

						Return (Zero)
					}

					Method (SXFP, 1, Serialized)
					{
						DBG2 ("SXFP", Arg0)
						If ((Arg0 == Zero)){}
					}
				}
			}

			Device (DSB1)
			{
				Name (_ADR, 0x00010000)	 // _ADR: Address
				Name (_SUN, One)  // _SUN: Slot User Number
				OperationRegion (A1E0, PCI_Config, Zero, 0x40)
				Field (A1E0, ByteAcc, NoLock, Preserve)
				{
					AVND,	32, 
					BMIE,	3, 
					Offset (0x18), 
					PRIB,	8, 
					SECB,	8, 
					SUBB,	8, 
					Offset (0x1E), 
						,	13, 
					MABT,	1
				}

				OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
				Field (A1E1, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					Offset (0x08), 
					Offset (0x0A), 
						,	5, 
					TPEN,	1, 
					Offset (0x0C), 
					SSPD,	4, 
						,	16, 
					LACR,	1, 
					Offset (0x10), 
						,	4, 
					LDIR,	1, 
					LRTN,	1, 
					Offset (0x12), 
					CSPD,	4, 
					CWDT,	6, 
						,	1, 
					LTRN,	1, 
						,	1, 
					LACT,	1, 
					Offset (0x14), 
					Offset (0x30), 
					TSPD,	4
				}

				OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
				Field (A1E2, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					PSTA,	2
				}

				Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
				{
					Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.SECB */
				}

				Method (_STA, 0, NotSerialized)	 // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
				{
					Return (Zero)
				}

				Device (UPS0)
				{
					Name (_ADR, Zero)  // _ADR: Address
					OperationRegion (ARE0, PCI_Config, Zero, 0x04)
					Field (ARE0, ByteAcc, NoLock, Preserve)
					{
						AVND,	16
					}

					Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
					{
						If (OSDW ())
						{
							Return (One)
						}

						Return (Zero)
					}

					Device (DSB0)
					{
						Name (_ADR, Zero)  // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1, 
							Offset (0x3E), 
								,	6, 
							SBRS,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB0.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}

						Device (DEV0)
						{
							Name (_ADR, Zero)  // _ADR: Address
							Method (_STA, 0, NotSerialized)	 // _STA: Status
							{
								Return (0x0F)
							}

							Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
							{
								If (OSDW ())
								{
									Return (One)
								}

								Return (Zero)
							}
						}
					}

					Device (DSB3)
					{
						Name (_ADR, 0x00030000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}

						Device (UPS0)
						{
							Name (_ADR, Zero)  // _ADR: Address
							OperationRegion (ARE0, PCI_Config, Zero, 0x04)
							Field (ARE0, ByteAcc, NoLock, Preserve)
							{
								AVND,	16
							}

							Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
							{
								If (OSDW ())
								{
									Return (One)
								}

								Return (Zero)
							}

							Device (DSB0)
							{
								Name (_ADR, Zero)  // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1, 
									Offset (0x3E), 
										,	6, 
									SBRS,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB0.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}
								}
							}

							Device (DSB3)
							{
								Name (_ADR, 0x00030000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB3.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB4)
							{
								Name (_ADR, 0x00040000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB4.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB5)
							{
								Name (_ADR, 0x00050000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB5.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}

							Device (DSB6)
							{
								Name (_ADR, 0x00060000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB6.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}
						}
					}

					Device (DSB4)
					{
						Name (_ADR, 0x00040000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}

						Device (UPS0)
						{
							Name (_ADR, Zero)  // _ADR: Address
							OperationRegion (ARE0, PCI_Config, Zero, 0x04)
							Field (ARE0, ByteAcc, NoLock, Preserve)
							{
								AVND,	16
							}

							Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
							{
								If (OSDW ())
								{
									Return (One)
								}

								Return (Zero)
							}

							Device (DSB0)
							{
								Name (_ADR, Zero)  // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1, 
									Offset (0x3E), 
										,	6, 
									SBRS,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB0.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB3)
							{
								Name (_ADR, 0x00030000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB3.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB4)
							{
								Name (_ADR, 0x00040000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB4.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB5)
							{
								Name (_ADR, 0x00050000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB5.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}

							Device (DSB6)
							{
								Name (_ADR, 0x00060000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB6.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}
						}
					}

					Device (DSB5)
					{
						Name (_ADR, 0x00050000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB5.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}
					}

					Device (DSB6)
					{
						Name (_ADR, 0x00060000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB6.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}
					}
				}
			}

			Device (DSB2)
			{
				Name (_ADR, 0x00020000)	 // _ADR: Address
				OperationRegion (A1E0, PCI_Config, Zero, 0x40)
				Field (A1E0, ByteAcc, NoLock, Preserve)
				{
					AVND,	32, 
					BMIE,	3, 
					Offset (0x18), 
					PRIB,	8, 
					SECB,	8, 
					SUBB,	8, 
					Offset (0x1E), 
						,	13, 
					MABT,	1
				}

				OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
				Field (A1E1, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					Offset (0x08), 
					Offset (0x0A), 
						,	5, 
					TPEN,	1, 
					Offset (0x0C), 
					SSPD,	4, 
						,	16, 
					LACR,	1, 
					Offset (0x10), 
						,	4, 
					LDIR,	1, 
					LRTN,	1, 
					Offset (0x12), 
					CSPD,	4, 
					CWDT,	6, 
						,	1, 
					LTRN,	1, 
						,	1, 
					LACT,	1, 
					Offset (0x14), 
					Offset (0x30), 
					TSPD,	4
				}

				OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
				Field (A1E2, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					PSTA,	2
				}

				Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
				{
					Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB2.SECB */
				}

				Method (_STA, 0, NotSerialized)	 // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
				{
					Return (Zero)
				}

				Name (IIP3, Zero)
				Name (PRSR, Zero)
				Name (PCIA, One)
				Method (PCEU, 0, Serialized)
				{
					DBG1 ("PCEU DSB2")
					\_SB.PCI0.RP05.UPSB.DSB2.PRSR = Zero
					DBG1 ("PCEU DSB2- Put upstream bridge back into D0 ")
					If ((\_SB.PCI0.RP05.UPSB.DSB2.PSTA != Zero))
					{
						DBG1 ("PCEU DSB2- exit D0, restored = true")
						\_SB.PCI0.RP05.UPSB.DSB2.PRSR = One
						\_SB.PCI0.RP05.UPSB.DSB2.PSTA = Zero
					}

					If ((\_SB.PCI0.RP05.UPSB.DSB2.LDIR == One))
					{
						DBG1 ("PCEU DSB2- Clear link disable on upstream bridge")
						DBG1 ("PCEU DSB2- clear link disable, restored = true")
						\_SB.PCI0.RP05.UPSB.DSB2.PRSR = One
						\_SB.PCI0.RP05.UPSB.DSB2.LDIR = Zero
					}
				}

				Method (PCDA, 0, Serialized)
				{
					DBG1 ("PCDA DSB2")
					If ((\_SB.PCI0.RP05.UPSB.DSB2.POFF () != Zero))
					{
						\_SB.PCI0.RP05.UPSB.DSB2.PCIA = Zero
						DBG1 ("PCDA DSB2- Put upstream bridge into D3")
						\_SB.PCI0.RP05.UPSB.DSB2.PSTA = 0x03
						DBG1 ("PCDA DSB2- Set link disable on upstream bridge")
						\_SB.PCI0.RP05.UPSB.DSB2.LDIR = One
						DBG1 ("PCDA DSB2- Wait for link to drop...")
						Local5 = (Timer + 0x00989680)
						While ((Timer <= Local5))
						{
							If ((\_SB.PCI0.RP05.UPSB.DSB2.LACR == One))
							{
								If ((\_SB.PCI0.RP05.UPSB.DSB2.LACT == Zero))
								{
									DBG1 ("PCDA DSB2- No link activity")
									Break
								}
							}
							ElseIf ((\_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND == 0xFFFFFFFF))
							{
								DBG1 ("PCDA DSB2- XHC2 not present")
								Break
							}

							Sleep (0x0A)
						}

						DBG1 ("PCDA DSB2 - disable GPIO")
						\_SB.PCI0.RP05.GXCI = Zero
						\_SB.PCI0.RP05.UGIO ()
					}
					Else
					{
						DBG1 ("PCDA DSB2- Not disabling")
					}

					\_SB.PCI0.RP05.UPSB.DSB2.IIP3 = One
				}

				Method (POFF, 0, Serialized)
				{
					DBG1 ("POFF DSB2")
					Return (!\_SB.PCI0.RP05.RUSB)
				}

				Method (_PS0, 0, Serialized)  // _PS0: Power State 0
				{
					DBG1 ("_PS0 DSB2")
					If (OSDW ())
					{
						PCEU ()
					}
				}

				Method (_PS3, 0, Serialized)  // _PS3: Power State 3
				{
					DBG1 ("_PS3 DSB2")
					If (OSDW ())
					{
						PCDA ()
					}
				}

				Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
				{
					If (OSDW ())
					{
						If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
						{
							Local0 = Package (0x02)
								{
									"PCIHotplugCapable", 
									Zero
								}
							DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
							Return (Local0)
						}
					}

					Return (Zero)
				}

				Device (XHC2)
				{
					Name (_ADR, Zero)  // _ADR: Address
					Name (SDPC, Zero)
					OperationRegion (A1E0, PCI_Config, Zero, 0x40)
					Field (A1E0, ByteAcc, NoLock, Preserve)
					{
						AVND,	32, 
						BMIE,	3, 
						Offset (0x18), 
						PRIB,	8, 
						SECB,	8, 
						SUBB,	8, 
						Offset (0x1E), 
							,	13, 
						MABT,	1
					}

					Method (PCED, 0, Serialized)
					{
						DBG1 ("PCED XHC2 - enable GPIO")
						\_SB.PCI0.RP05.GXCI = One
						If ((\_SB.PCI0.RP05.UGIO () != Zero))
						{
							DBG1 ("PCED XHC2 - GPIOs changed, restored = true")
							\_SB.PCI0.RP05.UPSB.DSB2.PRSR = One
						}

						Local0 = Zero
						Local1 = Zero
						Local3 = Zero
						While ((Local3 == Zero))
						{
							Local4 = Zero
							DBG2 ("PCED XHC2- restored flag, THUNDERBOLT_PCI_LINK_MGMT_DEVICE.PRSR", \_SB.PCI0.RP05.UPSB.DSB2.PRSR)
							Local5 = (Timer + 0x00989680)
							If ((\_SB.PCI0.RP05.UPSB.DSB2.PRSR != Zero))
							{
								DBG1 ("PCED XHC2- Wait for link training...")
								Local5 = (Timer + 0x00989680)
								While ((Timer <= Local5))
								{
									If ((\_SB.PCI0.RP05.UPSB.DSB2.LACR == Zero))
									{
										If ((\_SB.PCI0.RP05.UPSB.DSB2.LTRN != One))
										{
											DBG1 ("PCED XHC2- Link training cleared")
											Break
										}
									}
									ElseIf (((\_SB.PCI0.RP05.UPSB.DSB2.LTRN != One) && (\_SB.PCI0.RP05.UPSB.DSB2.LACT == One)))
									{
										DBG1 ("PCED XHC2- Link training cleared and link is active")
										Break
									}

									Sleep (0x0A)
								}

								Sleep (0x96)
							}

							DBG1 ("PCED XHC2- Wait for config space...")
							While ((Timer <= Local5))
							{
								If ((\_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND != 0xFFFFFFFF))
								{
									Local4 = One
									\_SB.PCI0.RP05.UPSB.DSB2.PCIA = One
									Break
								}

								Sleep (0x0A)
							}
						
							DBG2 ("PCED XHC2- Read VID/DID = ", \_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND)
							Local3 = One
						}

						\_SB.PCI0.RP05.UPSB.DSB2.PRSR = Zero
						\_SB.PCI0.RP05.UPSB.DSB2.IIP3 = Zero
					}

					Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
					{
						Local0 = Package (0x06)
							{
								"USBBusNumber", 
								Zero, 
								"AAPL,xhci-clock-id", 
								One, 
								"UsbCompanionControllerPresent", 
								One
							}

						DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
						Return (Local0)
					}

					Name (HS, Package (0x01)
					{
						"XHC"
					})
					Name (FS, Package (0x01)
					{
						"XHC"
					})
					Name (LS, Package (0x01)
					{
						"XHC"
					})
					Method (_PRW, 0, NotSerialized)	 // _PRW: Power Resources for Wake
					{
						If (OSDW ())
						{
							Return (Package (0x02)
							{
								0x6D, 
								0x04
							})
						}
						Else
						{
							Return (Package (0x02)
							{
								0x6D, 
								0x03
							})
						}
					}

					Method (_PS0, 0, Serialized)  // _PS0: Power State 0
					{
						DBG1 ("_PS0 XHC2")
						If (OSDW ())
						{
							PCED ()
						}
					}

					Method (_PS3, 0, Serialized)  // _PS3: Power State 3
					{
						DBG1 ("_PS3 XHC2, Nothing to do!")
					}

					Method (RTPC, 1, Serialized)
					{
						DBG2 ("RTPC XHC2 called with arg: ", Arg0)
						If (OSDW ())
						{
							If ((Arg0 <= One))
							{
								\_SB.PCI0.RP05.RUSB = Arg0
							}
						}

						Return (Zero)
					}

					Method (MODU, 0, Serialized)
					{
						DBG2 ("MODU - return = ", \_SB.PCI0.RP05.UPSB.MDUV)
						Return (\_SB.PCI0.RP05.UPSB.MDUV)
					}

					Device (RHUB)
					{
						Name (_ADR, Zero)  // _ADR: Address
						Device (SSP1)
						{
							Name (_ADR, 0x03)  // _ADR: Address
							Name (_UPC, Package (0x04)	// _UPC: USB Port Capabilities
							{
								0xFF, 
								0x09, 
								Zero, 
								Zero
							})
							Name (_PLD, Package (0x01)	// _PLD: Physical Location of Device
							{
								ToPLD (
									PLD_Revision		   = 0x1,
									PLD_IgnoreColor		   = 0x1,
									PLD_Red				   = 0x0,
									PLD_Green			   = 0x0,
									PLD_Blue			   = 0x0,
									PLD_Width			   = 0x0,
									PLD_Height			   = 0x0,
									PLD_UserVisible		   = 0x1,
									PLD_Dock			   = 0x0,
									PLD_Lid				   = 0x0,
									PLD_Panel			   = "UNKNOWN",
									PLD_VerticalPosition   = "UPPER",
									PLD_HorizontalPosition = "LEFT",
									PLD_Shape			   = "UNKNOWN",
									PLD_GroupOrientation   = 0x0,
									PLD_GroupToken		   = 0x0,
									PLD_GroupPosition	   = 0x0,
									PLD_Bay				   = 0x0,
									PLD_Ejectable		   = 0x0,
									PLD_EjectRequired	   = 0x0,
									PLD_CabinetNumber	   = 0x0,
									PLD_CardCageNumber	   = 0x0,
									PLD_Reference		   = 0x0,
									PLD_Rotation		   = 0x0,
									PLD_Order			   = 0x0,
									PLD_VerticalOffset	   = 0x0,
									PLD_HorizontalOffset   = 0x0)

							})
							Name (HS, Package (0x02)
							{
								"XHC", 
								0x08
							})
							Name (FS, Package (0x02)
							{
								"XHC", 
								0x08
							})
							Name (LS, Package (0x02)
							{
								"XHC", 
								0x08
							})
							Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
							{
								Local0 = Package (0x0A)
									{
										"UsbCPortNumber", 
										0x03, 
										"UsbPowerSource", 
										0x03, 
										"kUSBWakePortCurrentLimit", 
										0x0BB8, 
										"kUSBSleepPortCurrentLimit", 
										0x0BB8, 
										"UsbCompanionPortPresent", 
										One
									}
								DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
								Return (Local0)
							}
						}

						Device (SSP2)
						{
							Name (_ADR, 0x04)  // _ADR: Address
							Name (_UPC, Package (0x04)	// _UPC: USB Port Capabilities
							{
								0xFF, 
								0x09, 
								Zero, 
								Zero
							})
							Name (_PLD, Package (0x01)	// _PLD: Physical Location of Device
							{
								ToPLD (
									PLD_Revision		   = 0x1,
									PLD_IgnoreColor		   = 0x1,
									PLD_Red				   = 0x0,
									PLD_Green			   = 0x0,
									PLD_Blue			   = 0x0,
									PLD_Width			   = 0x0,
									PLD_Height			   = 0x0,
									PLD_UserVisible		   = 0x1,
									PLD_Dock			   = 0x0,
									PLD_Lid				   = 0x0,
									PLD_Panel			   = "UNKNOWN",
									PLD_VerticalPosition   = "UPPER",
									PLD_HorizontalPosition = "LEFT",
									PLD_Shape			   = "UNKNOWN",
									PLD_GroupOrientation   = 0x0,
									PLD_GroupToken		   = 0x0,
									PLD_GroupPosition	   = 0x0,
									PLD_Bay				   = 0x0,
									PLD_Ejectable		   = 0x0,
									PLD_EjectRequired	   = 0x0,
									PLD_CabinetNumber	   = 0x0,
									PLD_CardCageNumber	   = 0x0,
									PLD_Reference		   = 0x0,
									PLD_Rotation		   = 0x0,
									PLD_Order			   = 0x0,
									PLD_VerticalOffset	   = 0x0,
									PLD_HorizontalOffset   = 0x0)

							})
							Name (HS, Package (0x02)
							{
								"XHC", 
								0x0D
							})
							Name (FS, Package (0x02)
							{
								"XHC", 
								0x0D
							})
							Name (LS, Package (0x02)
							{
								"XHC", 
								0x0D
							})
							Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
							{
								Local0 = Package (0x0A)
									{
										"UsbCPortNumber", 
										0x04, 
										"UsbPowerSource", 
										0x04, 
										"kUSBWakePortCurrentLimit", 
										0x0BB8, 
										"kUSBSleepPortCurrentLimit", 
										0x0BB8, 
										"UsbCompanionPortPresent", 
										One
									}
								DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
								Return (Local0)
							}
						}
					}
				}
			}

			Device (DSB4)
			{
				Name (_ADR, 0x00040000)	 // _ADR: Address
				Name (_SUN, 0x02)  // _SUN: Slot User Number
				OperationRegion (A1E0, PCI_Config, Zero, 0x40)
				Field (A1E0, ByteAcc, NoLock, Preserve)
				{
					AVND,	32, 
					BMIE,	3, 
					Offset (0x18), 
					PRIB,	8, 
					SECB,	8, 
					SUBB,	8, 
					Offset (0x1E), 
						,	13, 
					MABT,	1
				}

				OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
				Field (A1E1, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					Offset (0x08), 
					Offset (0x0A), 
						,	5, 
					TPEN,	1, 
					Offset (0x0C), 
					SSPD,	4, 
						,	16, 
					LACR,	1, 
					Offset (0x10), 
						,	4, 
					LDIR,	1, 
					LRTN,	1, 
					Offset (0x12), 
					CSPD,	4, 
					CWDT,	6, 
						,	1, 
					LTRN,	1, 
						,	1, 
					LACT,	1, 
					Offset (0x14), 
					Offset (0x30), 
					TSPD,	4
				}

				OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
				Field (A1E2, ByteAcc, NoLock, Preserve)
				{
					Offset (0x01), 
					Offset (0x02), 
					Offset (0x04), 
					PSTA,	2
				}

				Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
				{
					Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.SECB */
				}

				Method (_STA, 0, NotSerialized)	 // _STA: Status
				{
					Return (0x0F)
				}

				Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
				{
					Return (Zero)
				}

				Device (UPS0)
				{
					Name (_ADR, Zero)  // _ADR: Address
					OperationRegion (ARE0, PCI_Config, Zero, 0x04)
					Field (ARE0, ByteAcc, NoLock, Preserve)
					{
						AVND,	16
					}

					Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
					{
						If (OSDW ())
						{
							Return (One)
						}

						Return (Zero)
					}

					Device (DSB0)
					{
						Name (_ADR, Zero)  // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1, 
							Offset (0x3E), 
								,	6, 
							SBRS,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB0.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}

						Device (DEV0)
						{
							Name (_ADR, Zero)  // _ADR: Address
							Method (_STA, 0, NotSerialized)	 // _STA: Status
							{
								Return (0x0F)
							}

							Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
							{
								If (OSDW ())
								{
									Return (One)
								}

								Return (Zero)
							}
						}
					}

					Device (DSB3)
					{
						Name (_ADR, 0x00030000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}

						Device (UPS0)
						{
							Name (_ADR, Zero)  // _ADR: Address
							OperationRegion (ARE0, PCI_Config, Zero, 0x04)
							Field (ARE0, ByteAcc, NoLock, Preserve)
							{
								AVND,	16
							}

							Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
							{
								If (OSDW ())
								{
									Return (One)
								}

								Return (Zero)
							}

							Device (DSB0)
							{
								Name (_ADR, Zero)  // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1, 
									Offset (0x3E), 
										,	6, 
									SBRS,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB0.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}
								}
							}

							Device (DSB3)
							{
								Name (_ADR, 0x00030000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB3.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB4)
							{
								Name (_ADR, 0x00040000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB4.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB5)
							{
								Name (_ADR, 0x00050000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB5.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}

							Device (DSB6)
							{
								Name (_ADR, 0x00060000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB6.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}
						}
					}

					Device (DSB4)
					{
						Name (_ADR, 0x00040000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}

						Device (UPS0)
						{
							Name (_ADR, Zero)  // _ADR: Address
							OperationRegion (ARE0, PCI_Config, Zero, 0x04)
							Field (ARE0, ByteAcc, NoLock, Preserve)
							{
								AVND,	16
							}

							Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
							{
								If (OSDW ())
								{
									Return (One)
								}

								Return (Zero)
							}

							Device (DSB0)
							{
								Name (_ADR, Zero)  // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1, 
									Offset (0x3E), 
										,	6, 
									SBRS,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB0.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB3)
							{
								Name (_ADR, 0x00030000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB3.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB4)
							{
								Name (_ADR, 0x00040000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB4.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}

								Device (DEV0)
								{
									Name (_ADR, Zero)  // _ADR: Address
									Method (_STA, 0, NotSerialized)	 // _STA: Status
									{
										Return (0x0F)
									}

									Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
									{
										If (OSDW ())
										{
											Return (One)
										}

										Return (Zero)
									}
								}
							}

							Device (DSB5)
							{
								Name (_ADR, 0x00050000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB5.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}

							Device (DSB6)
							{
								Name (_ADR, 0x00060000)	 // _ADR: Address
								OperationRegion (A1E0, PCI_Config, Zero, 0x40)
								Field (A1E0, ByteAcc, NoLock, Preserve)
								{
									AVND,	32, 
									BMIE,	3, 
									Offset (0x18), 
									PRIB,	8, 
									SECB,	8, 
									SUBB,	8, 
									Offset (0x1E), 
										,	13, 
									MABT,	1
								}

								Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
								{
									Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB6.SECB */
								}

								Method (_STA, 0, NotSerialized)	 // _STA: Status
								{
									Return (0x0F)
								}

								Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
								{
									If (OSDW ())
									{
										Return (One)
									}

									Return (Zero)
								}
							}
						}
					}

					Device (DSB5)
					{
						Name (_ADR, 0x00050000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB5.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}
					}

					Device (DSB6)
					{
						Name (_ADR, 0x00060000)	 // _ADR: Address
						OperationRegion (A1E0, PCI_Config, Zero, 0x40)
						Field (A1E0, ByteAcc, NoLock, Preserve)
						{
							AVND,	32, 
							BMIE,	3, 
							Offset (0x18), 
							PRIB,	8, 
							SECB,	8, 
							SUBB,	8, 
							Offset (0x1E), 
								,	13, 
							MABT,	1
						}

						Method (_BBN, 0, NotSerialized)	 // _BBN: BIOS Bus Number
						{
							Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB6.SECB */
						}

						Method (_STA, 0, NotSerialized)	 // _STA: Status
						{
							Return (0x0F)
						}

						Method (_RMV, 0, NotSerialized)	 // _RMV: Removal Status
						{
							If (OSDW ())
							{
								Return (One)
							}

							Return (Zero)
						}
					}
				}
			}

			Method (_DSM, 4, NotSerialized)	 // _DSM: Device-Specific Method
			{
				If (OSDW ())
				{
					If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
					{
						Local0 = Package (0x02)
							{
								"PCI-Thunderbolt", 
								One
							}
						DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
						Return (Local0)
					}
				}

				Return (Zero)
			}
		}
	}
}

