/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of iASLhS4pf1.aml, Tue Feb  4 10:21:43 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00003F9A (16282)
 *     Revision         0x02
 *     Checksum         0x46
 *     OEM ID           "OSY86 "
 *     OEM Table ID     "TbtOnPCH"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20180427 (538444839)
 */
DefinitionBlock ("", "SSDT", 2, "OSY86 ", "TbtOnPCH", 0x00001000)
{
    External (_SB_.PCI0.GPCB, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.RP05, DeviceObj)
    External (_SB_.PCI0.RP05.PXSX, DeviceObj)
    External (_SB_.PCI0.XHC_, DeviceObj)
    External (_SB_.SGOV, MethodObj)    // 2 Arguments
    External (DTGP, MethodObj)    // 5 Arguments
    External (FFTB, MethodObj)    // Check if Tbt Powered On (1=no, 0=yes)
    External (FP0L, FieldUnitObj)
    External (FPG0, FieldUnitObj)
    External (MMRP, MethodObj)    // Memory Mapped Root Port
    External (MMTB, MethodObj)    // Memory Mapped Thunderbolt Port
    External (OSDW, MethodObj)    // 0 Arguments
    External (OSUM, MutexObj)
    External (RMDT.P1__, MethodObj)    // 1 Arguments
    External (RMDT.P2__, MethodObj)    // 2 Arguments
    External (RMDT.P3__, MethodObj)    // 3 Arguments
    External (RPS0, FieldUnitObj)
    External (RPT0, FieldUnitObj)
    External (SOHP, FieldUnitObj)
    External (TBSE, FieldUnitObj)
    External (TNAT, FieldUnitObj)
    External (TWIN, FieldUnitObj)


    Scope (\_SB.PCI0.RP05)
    {
        Method (OHPE, 0, NotSerialized)
        {
            Return (One)
        }

        Method (MMIO, 3, NotSerialized)
        {
            Local0 = \_SB.PCI0.GPCB ()
            Local0 += (Arg0 << 0x14)
            Local0 += (Arg1 << 0x0F)
            Local0 += (Arg2 << 0x0C)
            Return (Local0)
        }

        Scope (PXSX)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (Zero)
            }
        }
    }

    Scope (\_GPE)
    {
        Method (_E17, 0, NotSerialized)  // _Exx: Edge-Triggered GPE, xx=0x00-0xFF
        {
            \_SB.PCI0.RP05.DBG1 ("Hot plug event")
            If (!\_SB.PCI0.RP05.OHPE ())
            {
                Return (Zero)
            }

            If (!OSDW ())
            {
                If ((\_SB.PCI0.RP05.POC0 == One))
                {
                    Return (Zero)
                }

                Sleep (0x0190)
                If ((\_SB.PCI0.RP05.WTLT () == One))
                {
                    \_SB.PCI0.RP05.ICMS ()
                }
                Else
                {
                }

                If (\_SB.PCI0.RP05.UPMB)
                {
                    \_SB.PCI0.RP05.UPMB = Zero
                    Sleep (One)
                }

                \_SB.PCI0.RP05.CMPE ()
            }
            Else
            {
                \_SB.PCI0.RP05.UPSB.AMPE ()
            }

            \_SB.PCI0.RP05.DBG1 ("End hotplug handler")
        }
    }

    Mutex (TCFG, 0x00)
    Scope (\_SB.PCI0.RP05)
    {
        Method (DBG1, 1, NotSerialized)
        {
            If (CondRefOf (\RMDT.P1))
            {
                \RMDT.P1 (Arg0)
            }
        }

        Method (DBG2, 2, NotSerialized)
        {
            If (CondRefOf (\RMDT.P2))
            {
                \RMDT.P2 (Arg0, Arg1)
            }
        }

        Method (DBG3, 3, NotSerialized)
        {
            If (CondRefOf (\RMDT.P3))
            {
                \RMDT.P3 (Arg0, Arg1, Arg2)
            }
        }

        Name (EICM, Zero)
        Name (R020, Zero)
        Name (R024, Zero)
        Name (R118, Zero)
        Name (R119, Zero)
        Name (R11A, Zero)
        Name (R11C, Zero)
        Name (R120, Zero)
        Name (R124, Zero)
        Name (R218, Zero)
        Name (R219, Zero)
        Name (R21A, Zero)
        Name (R21C, Zero)
        Name (R220, Zero)
        Name (R224, Zero)
        Name (R318, Zero)
        Name (R319, Zero)
        Name (R31A, Zero)
        Name (R31C, Zero)
        Name (R320, Zero)
        Name (R324, Zero)
        Name (R418, Zero)
        Name (R419, Zero)
        Name (R41A, Zero)
        Name (R41C, Zero)
        Name (R420, Zero)
        Name (R424, Zero)
        Name (RVES, Zero)
        Name (R518, Zero)
        Name (R519, Zero)
        Name (R51A, Zero)
        Name (R51C, Zero)
        Name (R520, Zero)
        Name (R524, Zero)
        Name (R618, Zero)
        Name (R619, Zero)
        Name (R61A, Zero)
        Name (R61C, Zero)
        Name (R620, Zero)
        Name (R624, Zero)
        Name (RH10, Zero)
        Name (RH14, Zero)
        Name (POC0, Zero)
        
        // Root port configuration base
        OperationRegion (RPSM, SystemMemory, MMRP (RPS0, RPT0), 0x54)
        Field (RPSM, DWordAcc, NoLock, Preserve)
        {
            RPVD,   32, 
            RPR4,   8, 
            Offset (0x18), 
            RP18,   8, 
            RP19,   8, 
            RP1A,   8, 
            Offset (0x1C), 
            RP1C,   16, 
            Offset (0x20), 
            R_20,   32, 
            R_24,   32, 
            Offset (0x52), 
                ,   11, 
            RPLT,   1, 
            Offset (0x54)
        }

        // UPSB (up stream port) configuration base
        OperationRegion (UPSM, SystemMemory, MMTB (RPS0, RPT0), 0x0550)
        Field (UPSM, DWordAcc, NoLock, Preserve)
        {
            UPVD,   32, 
            UP04,   8, 
            Offset (0x08), 
            CLRD,   32, 
            Offset (0x18), 
            UP18,   8, 
            UP19,   8, 
            UP1A,   8, 
            Offset (0x1C), 
            UP1C,   16, 
            Offset (0x20), 
            UP20,   32, 
            UP24,   32, 
            Offset (0xD2), 
                ,   11, 
            UPLT,   1, 
            Offset (0xD4), 
            Offset (0x544), 
            UPMB,   1, 
            Offset (0x548), 
            T2PR,   32, 
            P2TR,   32
        }

        // DSB0 configuration base
        OperationRegion (DNSM, SystemMemory, MMIO (UP19, Zero, Zero), 0xD4)
        Field (DNSM, DWordAcc, NoLock, Preserve)
        {
            DPVD,   32, 
            DP04,   8, 
            Offset (0x18), 
            DP18,   8, 
            DP19,   8, 
            DP1A,   8, 
            Offset (0x1C), 
            DP1C,   16, 
            Offset (0x20), 
            DP20,   32, 
            DP24,   32, 
            Offset (0xD2), 
                ,   11, 
            DPLT,   1, 
            Offset (0xD4)
        }

        // DSB1 configuration base
        OperationRegion (DS3M, SystemMemory, MMIO (UP19, One, Zero), 0x40)
        Field (DS3M, DWordAcc, NoLock, Preserve)
        {
            D3VD,   32, 
            D304,   8, 
            Offset (0x18), 
            D318,   8, 
            D319,   8, 
            D31A,   8, 
            Offset (0x1C), 
            D31C,   16, 
            Offset (0x20), 
            D320,   32, 
            D324,   32
        }

        // DSB2 configuration base
        OperationRegion (DS4M, SystemMemory, MMIO (UP19, 0x02, Zero), 0x0568)
        Field (DS4M, DWordAcc, NoLock, Preserve)
        {
            D4VD,   32, 
            D404,   8, 
            Offset (0x18), 
            D418,   8, 
            D419,   8, 
            D41A,   8, 
            Offset (0x1C), 
            D41C,   16, 
            Offset (0x20), 
            D420,   32, 
            D424,   32, 
            Offset (0x564), 
            DVES,   32
        }

        // DSB4 configuration base
        OperationRegion (DS5M, SystemMemory, MMIO (UP19, 0x04, Zero), 0x40)
        Field (DS5M, DWordAcc, NoLock, Preserve)
        {
            D5VD,   32, 
            D504,   8, 
            Offset (0x18), 
            D518,   8, 
            D519,   8, 
            D51A,   8, 
            Offset (0x1C), 
            D51C,   16, 
            Offset (0x20), 
            D520,   32, 
            D524,   32
        }

        OperationRegion (NHIM, SystemMemory, MMIO (DP19, Zero, Zero), 0x40)
        Field (NHIM, DWordAcc, NoLock, Preserve)
        {
            NH00,   32, 
            NH04,   8, 
            Offset (0x10), 
            NH10,   32, 
            NH14,   32
        }

        OperationRegion (RSTR, SystemMemory, (NH10 + 0x00039858), 0x0100)
        Field (RSTR, DWordAcc, NoLock, Preserve)
        {
            CIOR,   32, 
            Offset (0xB8), 
            ISTA,   32, 
            Offset (0xEC), 
            ICME,   32
        }

        OperationRegion (XHCM, SystemMemory, MMIO (D519, Zero, Zero), 0x40)
        Field (XHCM, DWordAcc, NoLock, Preserve)
        {
            XH00,   32, 
            XH04,   8, 
            Offset (0x10), 
            XH10,   32, 
            XH14,   32
        }

        Method (PINI, 0, NotSerialized)  // _INI: Initialize
        {
            If (OSDW ())
            {
                DBG3 ("RP", RPVD, R_20)
                DBG1 ("RP05 Initialize")
                Acquire (TCFG, 0xFFFF)
                R020 = R_20 /* \_SB_.PCI0.RP05.R_20 */
                R024 = R_24 /* \_SB_.PCI0.RP05.R_24 */
                R118 = UP18 /* \_SB_.PCI0.RP05.UP18 */
                R119 = (RP19 + One) /* \_SB_.PCI0.RP05.UP19 */
                R11A = UP1A /* \_SB_.PCI0.RP05.UP1A */
                R11C = UP1C /* \_SB_.PCI0.RP05.UP1C */
                R120 = UP20 /* \_SB_.PCI0.RP05.UP20 */
                R124 = UP24 /* \_SB_.PCI0.RP05.UP24 */
                R218 = DP18 /* \_SB_.PCI0.RP05.DP18 */
                R219 = (R119 + One) /* \_SB_.PCI0.RP05.DP19 */
                R21A = (R119 + One) /* \_SB_.PCI0.RP05.DP1A */
                R21C = DP1C /* \_SB_.PCI0.RP05.DP1C */
                R220 = DP20 /* \_SB_.PCI0.RP05.DP20 */
                R224 = DP24 /* \_SB_.PCI0.RP05.DP24 */
                R318 = D318 /* \_SB_.PCI0.RP05.D318 */
                R319 = (R219 + One) /* \_SB_.PCI0.RP05.D319 */
                R31A = (R219 + One) /* \_SB_.PCI0.RP05.D31A */
                R31C = Zero /* \_SB_.PCI0.RP05.D31C */
                R320 = Zero /* \_SB_.PCI0.RP05.D320 */
                R324 = Zero /* \_SB_.PCI0.RP05.D324 */
                R418 = R119 /* \_SB_.PCI0.RP05.D418 */
                R419 = (((RP1A - R219) >> One) + R219) /* \_SB_.PCI0.RP05.D419 */
                R41A = (((RP1A - R219) >> One) + R219) /* \_SB_.PCI0.RP05.D41A */
                R41C = Zero /* \_SB_.PCI0.RP05.D41C */
                R420 = Zero /* \_SB_.PCI0.RP05.D420 */
                R424 = Zero /* \_SB_.PCI0.RP05.D424 */
                RVES = Zero /* \_SB_.PCI0.RP05.DVES */
                R518 = R119 /* \_SB_.PCI0.RP05.D518 */
                R519 = (R319 + One) /* \_SB_.PCI0.RP05.D519 */
                R51A = (R319 + One) /* \_SB_.PCI0.RP05.D51A */
                R51C = Zero /* \_SB_.PCI0.RP05.D51C */
                R520 = Zero /* \_SB_.PCI0.RP05.D520 */
                R524 = Zero /* \_SB_.PCI0.RP05.D524 */
                RH10 = NH10 /* \_SB_.PCI0.RP05.NH10 */
                RH14 = NH14 /* \_SB_.PCI0.RP05.NH14 */
                Sleep (One)
                ICMB ()
                Release (TCFG)
            }
        }

        Method (ICMB, 0, NotSerialized)
        {
            DBG1 ("ICMBoot")
            Acquire (OSUM, 0xFFFF)
            Local1 = 0x64
            P2TR = 0x0D
            While ((Local1 > Zero))
            {
                Local1 -= One
                Local2 = T2PR /* \_SB_.PCI0.RP05.T2PR */
                If ((Local2 & One))
                {
                    Break
                }

                Sleep (0x32)
            }

            P2TR = 0x0C
            Release (OSUM)
            If (CondRefOf (TWIN))
            {
                DBG1 ("Tbt TWIN set to One")
                TWIN = One
            }

            DBG1 ("Tbt Force Power with FPG0")
            SGOV (FPG0, FP0L)
            Sleep (0x02F4)
            Local0 = 0x08D0
            Local1 = Timer
            While (Local0)
            {
                If (UPCK ())
                {
                    DBG2 ("Up Stream VID/DID =", UPVD)
                    Break
                }
                ElseIf ((Local0 == 0x07D0))
                {
                    DBG1 ("Slow ICM boot !")
                }

                Sleep (One)
                Local0--
            }

            If (!Local0)
            {
                DBG1 ("Tbt Device no boot !")
            }

            SOHP = Zero
            If (CondRefOf (TNAT))
            {
                DBG1 ("Tbt TNAT set to One")
                TNAT = One
            }

            ICMS ()
            DBG2 ("Configuration delay = ", Concatenate (ToDecimalString (((Timer - Local1) / 0x2710)), " ms"))
//            DBG1 (Concatenate ("UPSB- Read VID/DID =", \_SB.PCI0.RP05.UPSB.AVND))
//            DBG1 (Concatenate ("DSB0- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB0.AVND))
//            DBG1 (Concatenate ("NHI0- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND))
//            DBG1 (Concatenate ("Global NH00- Read VID/DID =", NH00))
//            DBG1 (Concatenate ("DSB2- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB2.AVND))
//            DBG1 (Concatenate ("XHC2- Read VID/DID =", \_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND))
//            DBG1 ("ICMB exiting")
            DBG2 ("RP18 =", RP18)
            DBG2 ("RP19 =", RP19)
            DBG2 ("RP1A =", RP1A)
            DBG2 ("RP1C =", RP1C)
            DBG2 ("R_20 =", R_20)
            DBG2 ("R_24 =", R_24)

            DBG2 ("UP18 =", UP18)
            DBG2 ("UP19 =", UP19)
            DBG2 ("UP1A =", UP1A)
            DBG2 ("UP1C =", UP1C)
            DBG2 ("UP20 =", UP20)
            DBG2 ("UP24 =", UP24)

            DBG2 ("DP18 =", DP18)
            DBG2 ("DP19 =", DP19)
            DBG2 ("DP1A =", DP1A)
            DBG2 ("DP1C =", DP1C)
            DBG2 ("DP20 =", DP20)
            DBG2 ("DP24 =", DP24)

            DBG2 ("D418 =", D418)
            DBG2 ("D419 =", D419)
            DBG2 ("D41A =", D41A)
            DBG2 ("D420 =", D420)
            DBG2 ("D424 =", D424)

            DBG2 ("NH10 =", NH10)
            DBG2 ("NH14 =", NH14)
        }
/*
    val |= REG_FW_STS_ICM_EN_INVERT;
    val |= REG_FW_STS_ICM_EN_CPU;
    
#define REG_FW_STS_ICM_EN_CPU		BIT(2)
#define REG_FW_STS_ICM_EN_INVERT	BIT(1)
*/
        Method (ICMS, 0, NotSerialized)
        {
            \_SB.PCI0.RP05.POC0 = One
            DBG2 ("ICME 1", \_SB.PCI0.RP05.ICME)
            If (((\_SB.PCI0.RP05.ICME != 0x800001A6) && (\_SB.PCI0.RP05.ICME != 0x800000A6)))
            {
                If (\_SB.PCI0.RP05.CNHI ())
                {
                    DBG2 ("ICME 2", \_SB.PCI0.RP05.ICME)
                    If ((\_SB.PCI0.RP05.ICME != 0xFFFFFFFF))
                    {
                        \_SB.PCI0.RP05.WTLT ()
                        DBG2 ("ICME 3", \_SB.PCI0.RP05.ICME)
                        If (Local0 = (\_SB.PCI0.RP05.ICME & 0x80000000)) // NVM_AUTH_DONE -- NVM started means we need reset
                        {
                            \_SB.PCI0.RP05.ICME |= 0x06// invert EN | enable CPU

                            Local0 = 0x03E8
                            While (((Local1 = (\_SB.PCI0.RP05.ICME & 0x80000000)) == Zero))
                            {
                                Local0--
                                If ((Local0 == Zero))
                                {
                                    Break
                                }

                                Sleep (One)
                            }

                            DBG2 ("ICME 4", \_SB.PCI0.RP05.ICME)
                        }
                    }
                }
            }

            \_SB.PCI0.RP05.POC0 = Zero
        }

        Method (TBTC, 1, Serialized)
        {
            P2TR = Arg0
            Local0 = 0x64
            Local1 = T2PR /* \_SB_.PCI0.RP05.T2PR */
            While (((Local2 = (Local1 & One)) == Zero))
            {
                If ((Local1 == 0xFFFFFFFF))
                {
                    Return (Zero)
                }

                Local0--
                If ((Local0 == Zero))
                {
                    Break
                }

                Local1 = T2PR /* \_SB_.PCI0.RP05.T2PR */
                Sleep (0x32)
            }

            P2TR = Zero
        }

        Method (CMPE, 0, Serialized)
        {
            Notify (\_SB.PCI0.RP05, Zero) // Bus Check
        }

        Method (CNHI, 0, Serialized)
        {
            Local0 = 0x0A
            DBG1 ("Configure root")
            While (Local0)
            {
                R_20 = R020 /* \_SB_.PCI0.RP05.R020 */
                R_24 = R024 /* \_SB_.PCI0.RP05.R024 */
                RPR4 = 0x07
                If ((R020 == R_20))
                {
                    Break
                }

                Sleep (One)
                Local0--
            }

            If ((R020 != R_20))
            {
                Return (Zero)
            }

            DBG1 ("Configure UPSB")
            Local0 = 0x0A
            While (Local0)
            {
                UP18 = R118 /* \_SB_.PCI0.RP05.R118 */
                UP19 = R119 /* \_SB_.PCI0.RP05.R119 */
                UP1A = R11A /* \_SB_.PCI0.RP05.R11A */
                UP1C = R11C /* \_SB_.PCI0.RP05.R11C */
                UP20 = R120 /* \_SB_.PCI0.RP05.R120 */
                UP24 = R124 /* \_SB_.PCI0.RP05.R124 */
                UP04 = 0x07
                If ((R119 == UP19))
                {
                    Break
                }

                Sleep (One)
                Local0--
            }

            If ((R119 != UP19))
            {
                Return (Zero)
            }

            DBG1 ("Wait for link training")
            If ((WTLT () != One))
            {
                Return (Zero)
            }

            DBG1 ("Configure DSB")
            Local0 = 0x0A
            While (Local0)
            {
                DP18 = R218 /* \_SB_.PCI0.RP05.R218 */
                DP19 = R219 /* \_SB_.PCI0.RP05.R219 */
                DP1A = R21A /* \_SB_.PCI0.RP05.R21A */
                DP1C = R21C /* \_SB_.PCI0.RP05.R21C */
                DP20 = R220 /* \_SB_.PCI0.RP05.R220 */
                DP24 = R224 /* \_SB_.PCI0.RP05.R224 */
                DP04 = 0x07
                D318 = R318 /* \_SB_.PCI0.RP05.R318 */
                D319 = R319 /* \_SB_.PCI0.RP05.R319 */
                D31A = R31A /* \_SB_.PCI0.RP05.R31A */
                D31C = R31C /* \_SB_.PCI0.RP05.R31C */
                D320 = R320 /* \_SB_.PCI0.RP05.R320 */
                D324 = R324 /* \_SB_.PCI0.RP05.R324 */
                D304 = 0x07
                D418 = R418 /* \_SB_.PCI0.RP05.R418 */
                D419 = R419 /* \_SB_.PCI0.RP05.R419 */
                D41A = R41A /* \_SB_.PCI0.RP05.R41A */
                D41C = R41C /* \_SB_.PCI0.RP05.R41C */
                D420 = R420 /* \_SB_.PCI0.RP05.R420 */
                D424 = R424 /* \_SB_.PCI0.RP05.R424 */
                DVES = RVES /* \_SB_.PCI0.RP05.RVES */
                D404 = 0x07
                D518 = R518 /* \_SB_.PCI0.RP05.R518 */
                D519 = R519 /* \_SB_.PCI0.RP05.R519 */
                D51A = R51A /* \_SB_.PCI0.RP05.R51A */
                D51C = R51C /* \_SB_.PCI0.RP05.R51C */
                D520 = R520 /* \_SB_.PCI0.RP05.R520 */
                D524 = R524 /* \_SB_.PCI0.RP05.R524 */
                D504 = 0x07
                If ((R219 == DP19))
                {
                    Break
                }

                Sleep (One)
                Local0--
            }

            If ((R219 != DP19))
            {
                Return (Zero)
            }

            DBG1 ("Wait for down link")
            If ((WTDL () != One))
            {
                Return (Zero)
            }

            DBG1 ("Configure NHI")
            Local0 = 0x64
            While (Local0)
            {
                NH10 = RH10 /* \_SB_.PCI0.RP05.RH10 */
                NH14 = RH14 /* \_SB_.PCI0.RP05.RH14 */
                NH04 = 0x07
                If ((RH10 == NH10))
                {
                    Break
                }

                Sleep (One)
                Local0--
            }

            DBG2 ("NHI BAR", NH10)
            If ((RH10 != NH10))
            {
                Return (Zero)
            }

            DBG1 ("CNHI done")
            Return (One)
        }

        Method (UPCK, 0, Serialized)
        {
            If (((UPVD & 0xFFFF) == 0x8086))
            {
                Return (One)
            }
            Else
            {
                Return (Zero)
            }
        }

        Method (ULTC, 0, Serialized)
        {
            If ((RPLT == Zero))
            {
                If ((UPLT == Zero))
                {
                    Return (One)
                }
            }

            Return (Zero)
        }

        Method (WTLT, 0, Serialized)
        {
            Local0 = 0x07D0
            Local1 = Zero
            While (Local0)
            {
                If ((RPR4 == 0x07))
                {
                    If (ULTC ())
                    {
                        If (UPCK ())
                        {
                            Local1 = One
                            Break
                        }
                    }
                }

                Sleep (One)
                Local0--
            }

            Return (Local1)
        }

        Method (DLTC, 0, Serialized)
        {
            If ((RPLT == Zero))
            {
                If ((UPLT == Zero))
                {
                    If ((DPLT == Zero))
                    {
                        Return (One)
                    }
                }
            }

            Return (Zero)
        }

        Method (WTDL, 0, Serialized)
        {
            Local0 = 0x07D0
            Local1 = Zero
            While (Local0)
            {
                If ((RPR4 == 0x07))
                {
                    If (DLTC ())
                    {
                        If (UPCK ())
                        {
                            Local1 = One
                            Break
                        }
                    }
                }

                Sleep (One)
                Local0--
            }

            Return (Local1)
        }

        Name (IIP3, Zero)
        Name (PRSR, Zero)
        Name (PCIA, One)
        Method (PCEU, 0, Serialized)
        {
            \_SB.PCI0.RP05.PRSR = Zero
            If ((\_SB.PCI0.RP05.PSTA != Zero))
            {
                \_SB.PCI0.RP05.PRSR = One
                \_SB.PCI0.RP05.PSTA = Zero
            }

            If ((\_SB.PCI0.RP05.LDXX == One))
            {
                \_SB.PCI0.RP05.PRSR = One
                \_SB.PCI0.RP05.LDXX = Zero
            }
        }

        Method (PCDA, 0, Serialized)
        {
            If ((\_SB.PCI0.RP05.POFF () != Zero))
            {
                \_SB.PCI0.RP05.PCIA = Zero
                \_SB.PCI0.RP05.PSTA = 0x03
                \_SB.PCI0.RP05.LDXX = One
                Local5 = (Timer + 0x00989680)
                While ((Timer <= Local5))
                {
                    If ((\_SB.PCI0.RP05.LACR == One))
                    {
                        If ((\_SB.PCI0.RP05.LACT == Zero))
                        {
                            Break
                        }
                    }
                    ElseIf ((\_SB.PCI0.RP05.UPSB.AVND == 0xFFFFFFFF))
                    {
                        Break
                    }

                    Sleep (0x0A)
                }

                \_SB.PCI0.RP05.GPCI = Zero
                \_SB.PCI0.RP05.UGIO ()
            }
            Else
            {
            }

            \_SB.PCI0.RP05.IIP3 = One
        }

        Method (POFF, 0, Serialized)
        {
            Return ((!\_SB.PCI0.RP05.RTBT && !\_SB.PCI0.RP05.RUSB))
        }

        Name (GPCI, One)
        Name (GNHI, One)
        Name (GXCI, One)
        Name (RTBT, One)
        Name (RUSB, One)
        Name (CTPD, Zero)
        Method (CTBT, 0, Serialized)
        {
            If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
            {
                Local2 = \_SB.PCI0.RP05.UPSB.CRMW (0x3C, Zero, 0x02, 0x04000000, 0x04000000)
                If ((Local2 == Zero))
                {
                    \_SB.PCI0.RP05.CTPD = One
                }
            }
        }

        Method (UGIO, 0, Serialized)
        {
            Local0 = (\_SB.PCI0.RP05.GNHI || \_SB.PCI0.RP05.RTBT)
            Local1 = (\_SB.PCI0.RP05.GXCI || \_SB.PCI0.RP05.RUSB)
            DBG3 ("UGIO", Local0, Local1)
            If ((\_SB.PCI0.RP05.GPCI != Zero))
            {
                If (((Local0 == Zero) && (Local1 == Zero)))
                {
                    Local0 = One
                    Local1 = One
                }
            }
            
            Local2 = Zero
            If (((Local0 != Zero) || (Local1 != Zero)))
            {
                DBG1 ("UGIO - Make sure TBT & USBC is on")
                If ((FFTB (RPS0, RPT0) == One))  // FFTB retuns One if Tbt is OFF
//                If ((GGOV (FPG0) != FP0L))
                {
                    DBG1 ("UGIO - Turn on TBT & USBC GPIO")
                    SGOV (FPG0, FP0L)
                    Local2 = One
                    \_SB.PCI0.RP05.CTPD = Zero
                }
            }
/*
            Local2 = Zero
            If ((Local0 != Zero))
            {
                If (Zero)
                {
                    Local2 = One
                    \_SB.PCI0.RP05.CTPD = Zero
                }
            }

            If ((Local1 != Zero))
            {
                If (Zero)
                {
                    Local2 = One
                }
            }
*/
            If ((Local2 != Zero))
            {
                Sleep (0x01F4)
            }
            
            Local3 = Zero
            If (((Local0 == Zero) && (Local1 == Zero)))
            {
                If ((FFTB (RPS0, RPT0) == Zero))  // FFTB retuns Zero if Tbt is ON
//                If ((GGOV (FPG0) == FP0L))
                {
                    DBG1 ("UGIO - Make sure TBT & USBC is off")
                    \_SB.PCI0.RP05.CTBT ()
                    If ((\_SB.PCI0.RP05.CTPD != Zero))
                    {
                        DBG1 ("UGIO - Turn off TBT & USBC GPIO")
                        SGOV (FPG0, !FP0L)
                        Local3 = One
                    }
                    Else
                    {
                        DBG1 ("UGIO - CP_ACK_POWERDOWN_OVERRIDE not configured, cannot turn off TBT GPIO")
                    }
                }
            }

/*
            Local3 = Zero
            If ((Local0 == Zero))
            {
                If (Zero)
                {
                    \_SB.PCI0.RP05.CTBT ()
                    If ((\_SB.PCI0.RP05.CTPD != Zero))
                    {
                        Local3 = One
                    }
                }
            }

            If ((Local1 == Zero))
            {
                If (Zero)
                {
                    Local3 = One
                }
            }
*/
            If ((Local3 != Zero))
            {
                Sleep (0x64)
            }

            DBG3 ("UGIO finish", Local2, Local3)
            Return (Local2)
        }

        Method (_PS0, 0, Serialized)  // _PS0: Power State 0
        {
            If (OSDW ())
            {
                PCEU ()
            }
        }

        Method (_PS3, 0, Serialized)  // _PS3: Power State 3
        {
            If (OSDW ())
            {
                If ((\_SB.PCI0.RP05.POFF () != Zero))
                {
                    \_SB.PCI0.RP05.CTBT ()
                }

                PCDA ()
            }
        }

        Method (UTLK, 2, Serialized)
        {
            Local0 = Zero
            If (Zero)
            {
                \_SB.PCI0.RP05.PSTA = Zero
                While (One)
                {
                    If ((\_SB.PCI0.RP05.LDXX == One))
                    {
                        \_SB.PCI0.RP05.LDXX = Zero
                    }

                    Local1 = Zero
                    Local2 = (Timer + 0x00989680)
                    While ((Timer <= Local2))
                    {
                        If ((\_SB.PCI0.RP05.LACR == Zero))
                        {
                            If ((\_SB.PCI0.RP05.LTRN != One))
                            {
                                Break
                            }
                        }
                        ElseIf (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)))
                        {
                            Break
                        }

                        Sleep (0x0A)
                    }

                    Sleep (Arg1)
                    While ((Timer <= Local2))
                    {
                        If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
                        {
                            Local1 = One
                            Break
                        }

                        Sleep (0x0A)
                    }

                    If ((Local1 == One))
                    {
                        \_SB.PCI0.RP05.MABT = One
                        Break
                    }

                    If ((Local0 == 0x04))
                    {
                        Break
                    }

                    Local0++
                    Sleep (0x03E8)
                }
            }
        }

        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
        Field (A1E0, ByteAcc, NoLock, Preserve)
        {
            AVND,   32, 
            BMIE,   3, 
            Offset (0x18), 
            PRIB,   8, 
            SECB,   8, 
            SUBB,   8, 
            Offset (0x1E), 
                ,   13, 
            MABT,   1
        }

        OperationRegion (HD94, PCI_Config, 0x0D94, 0x08)
        Field (HD94, ByteAcc, NoLock, Preserve)
        {
            Offset (0x04), 
            PLEQ,   1, 
            Offset (0x08)
        }

        OperationRegion (A1E1, PCI_Config, 0x40, 0x40)
        Field (A1E1, ByteAcc, NoLock, Preserve)
        {
            Offset (0x01), 
            Offset (0x02), 
            Offset (0x04), 
            Offset (0x08), 
            Offset (0x0A), 
                ,   5, 
            TPEN,   1, 
            Offset (0x0C), 
            SSPD,   4, 
                ,   16, 
            LACR,   1, 
            Offset (0x10), 
                ,   4, 
            LDXX,   1, 
            LRTN,   1, 
            Offset (0x12), 
            CSPD,   4, 
            CWDT,   6, 
                ,   1, 
            LTRN,   1, 
                ,   1, 
            LACT,   1, 
            Offset (0x14), 
            Offset (0x30), 
            TSPD,   4
        }

        OperationRegion (A1E2, PCI_Config, 0xA0, 0x08)
        Field (A1E2, ByteAcc, NoLock, Preserve)
        {
            Offset (0x01), 
            Offset (0x02), 
            Offset (0x04), 
            PSTA,   2
        }

        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
        {
            Return (Zero)
        }

        Device (UPSB)
        {
            Name (_ADR, Zero)  // _ADR: Address
            OperationRegion (A1E0, PCI_Config, Zero, 0x40)
            Field (A1E0, ByteAcc, NoLock, Preserve)
            {
                AVND,   32, 
                BMIE,   3, 
                Offset (0x18), 
                PRIB,   8, 
                SECB,   8, 
                SUBB,   8, 
                Offset (0x1E), 
                    ,   13, 
                MABT,   1
            }

            OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
            Field (A1E1, ByteAcc, NoLock, Preserve)
            {
                Offset (0x01), 
                Offset (0x02), 
                Offset (0x04), 
                Offset (0x08), 
                Offset (0x0A), 
                    ,   5, 
                TPEN,   1, 
                Offset (0x0C), 
                SSPD,   4, 
                    ,   16, 
                LACR,   1, 
                Offset (0x10), 
                    ,   4, 
                LDIS,   1, 
                LRTN,   1, 
                Offset (0x12), 
                CSPD,   4, 
                CWDT,   6, 
                    ,   1, 
                LTRN,   1, 
                    ,   1, 
                LACT,   1, 
                Offset (0x14), 
                Offset (0x30), 
                TSPD,   4
            }

            OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
            Field (A1E2, ByteAcc, NoLock, Preserve)
            {
                Offset (0x01), 
                Offset (0x02), 
                Offset (0x04), 
                PSTA,   2
            }

            Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
            {
                Return (SECB) /* \_SB_.PCI0.RP05.UPSB.SECB */
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (0x0F)
            }

            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
            {
                Return (Zero)
            }

            Method (PCED, 0, Serialized)
            {
                \_SB.PCI0.RP05.GPCI = One
                If ((\_SB.PCI0.RP05.UGIO () != Zero))
                {
                    \_SB.PCI0.RP05.PRSR = One
                }

                Local0 = Zero
                Local1 = Zero
                If ((Local1 == Zero))
                {
                    If ((\_SB.PCI0.RP05.IIP3 != Zero))
                    {
                        \_SB.PCI0.RP05.PRSR = One
                        Local0 = One
                        \_SB.PCI0.RP05.LDXX = One
                    }
                }

                Local5 = (Timer + 0x00989680)
                If ((\_SB.PCI0.RP05.PRSR != Zero))
                {
                    Sleep (0x1E)
                    If (((Local0 != Zero) || (Local1 != Zero)))
                    {
                        \_SB.PCI0.RP05.TSPD = One
                        If ((Local1 != Zero)){}
                        ElseIf ((Local0 != Zero))
                        {
                            \_SB.PCI0.RP05.LDXX = Zero
                        }

                        While ((Timer <= Local5))
                        {
                            If ((\_SB.PCI0.RP05.LACR == Zero))
                            {
                                If ((\_SB.PCI0.RP05.LTRN != One))
                                {
                                    Break
                                }
                            }
                            ElseIf (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)))
                            {
                                Break
                            }

                            Sleep (0x0A)
                        }

                        Sleep (0x78)
                        While ((Timer <= Local5))
                        {
                            If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
                            {
                                Break
                            }

                            Sleep (0x0A)
                        }

                        \_SB.PCI0.RP05.TSPD = 0x03
                        \_SB.PCI0.RP05.LRTN = One
                    }

                    Local5 = (Timer + 0x00989680)
                    While ((Timer <= Local5))
                    {
                        If ((\_SB.PCI0.RP05.LACR == Zero))
                        {
                            If ((\_SB.PCI0.RP05.LTRN != One))
                            {
                                Break
                            }
                        }
                        ElseIf (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)))
                        {
                            Break
                        }

                        Sleep (0x0A)
                    }

                    Sleep (0xFA)
                }

                \_SB.PCI0.RP05.PRSR = Zero
                While ((Timer <= Local5))
                {
                    If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
                    {
                        Break
                    }

                    Sleep (0x0A)
                }

                If ((\_SB.PCI0.RP05.CSPD != 0x03))
                {
                    If ((\_SB.PCI0.RP05.SSPD == 0x03))
                    {
                        If ((\_SB.PCI0.RP05.UPSB.SSPD == 0x03))
                        {
                            If ((\_SB.PCI0.RP05.TSPD != 0x03))
                            {
                                \_SB.PCI0.RP05.TSPD = 0x03
                            }

                            If ((\_SB.PCI0.RP05.UPSB.TSPD != 0x03))
                            {
                                \_SB.PCI0.RP05.UPSB.TSPD = 0x03
                            }

                            \_SB.PCI0.RP05.LRTN = One
                            Local2 = (Timer + 0x00989680)
                            While ((Timer <= Local2))
                            {
                                If ((\_SB.PCI0.RP05.LACR == Zero))
                                {
                                    If (((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF)))
                                    {
                                        \_SB.PCI0.RP05.PCIA = One
                                        Local1 = One
                                        Break
                                    }
                                }
                                ElseIf ((((\_SB.PCI0.RP05.LTRN != One) && (\_SB.PCI0.RP05.LACT == One)) && 
                                    (\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF)))
                                {
                                    \_SB.PCI0.RP05.PCIA = One
                                    Local1 = One
                                    Break
                                }

                                Sleep (0x0A)
                            }
                        }
                        Else
                        {
                            \_SB.PCI0.RP05.PCIA = One
                        }
                    }
                    Else
                    {
                        \_SB.PCI0.RP05.PCIA = One
                    }
                }
                Else
                {
                    \_SB.PCI0.RP05.PCIA = One
                }

                \_SB.PCI0.RP05.IIP3 = Zero
            }

            Method (AMPE, 0, Serialized)
            {
                Notify (\_SB.PCI0.RP05.UPSB.DSB0.NHI0, Zero) // Bus Check
            }

            Method (UMPE, 0, Serialized)
            {
                Notify (\_SB.PCI0.RP05.UPSB.DSB2.XHC2, Zero) // Bus Check
                Notify (\_SB.PCI0.XHC, Zero) // Bus Check
            }

            Name (MDUV, One)
            Method (MUST, 1, Serialized)
            {
                DBG2 ("MUST", Arg0)
                If (OSDW ())
                {
                    If ((MDUV != Arg0))
                    {
                        MDUV = Arg0
                        UMPE ()
                    }
                }

                Return (Zero)
            }

            Method (_PS0, 0, Serialized)  // _PS0: Power State 0
            {
                If (OSDW ())
                {
                    PCED ()
                    \_SB.PCI0.RP05.UPSB.CRMW (0x013E, Zero, 0x02, 0x0200, 0x0200)
                    \_SB.PCI0.RP05.UPSB.CRMW (0x023E, Zero, 0x02, 0x0200, 0x0200)
                }
            }

            Method (_PS3, 0, Serialized)  // _PS3: Power State 3
            {
                If (!OSDW ())
                {
                    If ((\_SB.PCI0.RP05.UPCK () == Zero))
                    {
                        \_SB.PCI0.RP05.UTLK (One, 0x03E8)
                    }

                    \_SB.PCI0.RP05.TBTC (0x05)
                }
            }

            OperationRegion (H548, PCI_Config, 0x0548, 0x20)
            Field (H548, DWordAcc, Lock, Preserve)
            {
                T2PC,   32, 
                PC2T,   32
            }

            OperationRegion (H530, PCI_Config, 0x0530, 0x0C)
            Field (H530, DWordAcc, Lock, Preserve)
            {
                DWIX,   13, 
                PORT,   6, 
                SPCE,   2, 
                CMD0,   1, 
                CMD1,   1, 
                CMD2,   1, 
                    ,   6, 
                PROG,   1, 
                TMOT,   1, 
                WDAT,   32, 
                RDAT,   32
            }

            Method (CIOW, 4, Serialized)
            {
                WDAT = Arg3
                DWIX = Arg0
                PORT = Arg1
                SPCE = Arg2
                CMD0 = One
                CMD1 = Zero
                CMD2 = Zero
                TMOT = Zero
                PROG = One
                Local1 = One
                Local0 = 0x2710
                While ((Zero < Local0))
                {
                    If ((PROG == Zero))
                    {
                        Local1 = Zero
                        Break
                    }

                    Stall (0x19)
                    Local0--
                }

                If ((Local1 == Zero))
                {
                    Local1 = TMOT /* \_SB_.PCI0.RP05.UPSB.TMOT */
                }

                Return (Local1)
            }

            Method (CIOR, 3, Serialized)
            {
                RDAT = Zero
                DWIX = Arg0
                PORT = Arg1
                SPCE = Arg2
                CMD0 = Zero
                CMD1 = Zero
                CMD2 = Zero
                TMOT = Zero
                PROG = One
                Local1 = One
                Local0 = 0x2710
                While ((Zero < Local0))
                {
                    If ((PROG == Zero))
                    {
                        Local1 = Zero
                        Break
                    }

                    Stall (0x19)
                    Local0--
                }

                If ((Local1 == Zero))
                {
                    Local1 = TMOT /* \_SB_.PCI0.RP05.UPSB.TMOT */
                }

                If ((Local1 == Zero))
                {
                    Return (Package (0x02)
                    {
                        Zero, 
                        RDAT
                    })
                }
                Else
                {
                    Return (Package (0x02)
                    {
                        One, 
                        RDAT
                    })
                }
            }

            Method (CRMW, 5, Serialized)
            {
                Local1 = One
                If ((\_SB.PCI0.RP05.UPSB.AVND != 0xFFFFFFFF))
                {
                    Local3 = Zero
                    While ((Local3 <= 0x04))
                    {
                        Local2 = CIOR (Arg0, Arg1, Arg2)
                        If ((DerefOf (Local2 [Zero]) == Zero))
                        {
                            Local2 = DerefOf (Local2 [One])
                            Local2 &= ~Arg4
                            Local2 |= Arg3
                            Local2 = CIOW (Arg0, Arg1, Arg2, Local2)
                            If ((Local2 == Zero))
                            {
                                Local2 = CIOR (Arg0, Arg1, Arg2)
                                If ((DerefOf (Local2 [Zero]) == Zero))
                                {
                                    Local2 = DerefOf (Local2 [One])
                                    Local2 &= Arg4
                                    If ((Local2 == Arg3))
                                    {
                                        Local1 = Zero
                                        Break
                                    }
                                }
                            }
                        }

                        Local3++
                        Sleep (0x64)
                    }
                }

                DBG3 ("CRMW", Arg0, Local1)
                Return (Local1)
            }

            Method (LSTX, 2, Serialized)
            {
                If ((T2PC != 0xFFFFFFFF))
                {
                    Local0 = Zero
                    If (((T2PC & One) && One))
                    {
                        Local0 = One
                    }

                    If ((Local0 == Zero))
                    {
                        Local1 = 0x2710
                        While ((Zero < Local1))
                        {
                            If ((T2PC == Zero))
                            {
                                Break
                            }

                            Stall (0x19)
                            Local1--
                        }

                        If ((Zero == Local1))
                        {
                            Local0 = One
                        }
                    }

                    If ((Local0 == Zero))
                    {
                        Local1 = One
                        Local1 |= 0x14
                        Local1 |= (Arg0 << 0x08)
                        Local1 |= (Arg1 << 0x0C)
                        Local1 |= 0x00400000
                        PC2T = Local1
                    }

                    If ((Local0 == Zero))
                    {
                        Local1 = 0x2710
                        While ((Zero < Local1))
                        {
                            If ((T2PC == 0x15))
                            {
                                Break
                            }

                            Stall (0x19)
                            Local1--
                        }

                        If ((Zero == Local1))
                        {
                            Local0 = One
                        }
                    }

                    PC2T = Zero
                }
            }

            Device (DSB0)
            {
                Name (_ADR, Zero)  // _ADR: Address
                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                Field (A1E0, ByteAcc, NoLock, Preserve)
                {
                    AVND,   32, 
                    BMIE,   3, 
                    Offset (0x18), 
                    PRIB,   8, 
                    SECB,   8, 
                    SUBB,   8, 
                    Offset (0x1E), 
                        ,   13, 
                    MABT,   1
                }

                OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
                Field (A1E1, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    Offset (0x08), 
                    Offset (0x0A), 
                        ,   5, 
                    TPEN,   1, 
                    Offset (0x0C), 
                    SSPD,   4, 
                        ,   16, 
                    LACR,   1, 
                    Offset (0x10), 
                        ,   4, 
                    LDIS,   1, 
                    LRTN,   1, 
                    Offset (0x12), 
                    CSPD,   4, 
                    CWDT,   6, 
                        ,   1, 
                    LTRN,   1, 
                        ,   1, 
                    LACT,   1, 
                    Offset (0x14), 
                    Offset (0x30), 
                    TSPD,   4
                }

                OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
                Field (A1E2, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    PSTA,   2
                }

                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                {
                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB0.SECB */
                }

                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (0x0F)
                }

                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                {
                    Return (Zero)
                }

                Name (IIP3, Zero)
                Name (PRSR, Zero)
                Name (PCIA, One)
                Method (PCEU, 0, Serialized)
                {
                    \_SB.PCI0.RP05.UPSB.DSB0.PRSR = Zero
                    If ((\_SB.PCI0.RP05.UPSB.DSB0.PSTA != Zero))
                    {
                        \_SB.PCI0.RP05.UPSB.DSB0.PRSR = One
                        \_SB.PCI0.RP05.UPSB.DSB0.PSTA = Zero
                    }

                    If ((\_SB.PCI0.RP05.UPSB.DSB0.LDIS == One))
                    {
                        \_SB.PCI0.RP05.UPSB.DSB0.PRSR = One
                        \_SB.PCI0.RP05.UPSB.DSB0.LDIS = Zero
                    }
                }

                Method (PCDA, 0, Serialized)
                {
                    If ((\_SB.PCI0.RP05.UPSB.DSB0.POFF () != Zero))
                    {
                        \_SB.PCI0.RP05.UPSB.DSB0.PCIA = Zero
                        \_SB.PCI0.RP05.UPSB.DSB0.PSTA = 0x03
                        \_SB.PCI0.RP05.UPSB.DSB0.LDIS = One
                        Local5 = (Timer + 0x00989680)
                        While ((Timer <= Local5))
                        {
                            If ((\_SB.PCI0.RP05.UPSB.DSB0.LACR == One))
                            {
                                If ((\_SB.PCI0.RP05.UPSB.DSB0.LACT == Zero))
                                {
                                    Break
                                }
                            }
                            ElseIf ((\_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND == 0xFFFFFFFF))
                            {
                                Break
                            }

                            Sleep (0x0A)
                        }

                        \_SB.PCI0.RP05.GNHI = Zero
                        \_SB.PCI0.RP05.UGIO ()
                    }
                    Else
                    {
                    }

                    \_SB.PCI0.RP05.UPSB.DSB0.IIP3 = One
                }

                Method (POFF, 0, Serialized)
                {
                    Return (!\_SB.PCI0.RP05.RTBT)
                }

                Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                {
                    If (OSDW ())
                    {
                        PCEU ()
                    }
                }

                Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                {
                    If (OSDW ())
                    {
                        PCDA ()
                    }
                }

                Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                {
                    If (OSDW ())
                    {
                        If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                        {
                            Local0 = Package (0x02)
                                {
                                    "PCIHotplugCapable", 
                                    Zero
                                }
                            DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                            Return (Local0)
                        }
                    }

                    Return (Zero)
                }

                Device (NHI0)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Name (_STR, Unicode ("Thunderbolt"))  // _STR: Description String
                    Method (PCED, 0, Serialized)
                    {
                        \_SB.PCI0.RP05.GNHI = One
                        If ((\_SB.PCI0.RP05.UGIO () != Zero))
                        {
                            \_SB.PCI0.RP05.UPSB.DSB0.PRSR = One
                        }

                        Local0 = Zero
                        Local1 = Zero
                        Local5 = (Timer + 0x00989680)
                        If ((\_SB.PCI0.RP05.UPSB.DSB0.PRSR != Zero))
                        {
                            Local5 = (Timer + 0x00989680)
                            While ((Timer <= Local5))
                            {
                                If ((\_SB.PCI0.RP05.UPSB.DSB0.LACR == Zero))
                                {
                                    If ((\_SB.PCI0.RP05.UPSB.DSB0.LTRN != One))
                                    {
                                        Break
                                    }
                                }
                                ElseIf (((\_SB.PCI0.RP05.UPSB.DSB0.LTRN != One) && (\_SB.PCI0.RP05.UPSB.DSB0.LACT == One)))
                                {
                                    Break
                                }

                                Sleep (0x0A)
                            }

                            Sleep (0x96)
                        }

                        \_SB.PCI0.RP05.UPSB.DSB0.PRSR = Zero
                        While ((Timer <= Local5))
                        {
                            If ((\_SB.PCI0.RP05.UPSB.DSB0.NHI0.AVND != 0xFFFFFFFF))
                            {
                                \_SB.PCI0.RP05.UPSB.DSB0.PCIA = One
                                Break
                            }

                            Sleep (0x0A)
                        }

                        \_SB.PCI0.RP05.UPSB.DSB0.IIP3 = Zero
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (Zero)
                    }

                    OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x10), 
                        BAR1,   32, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    Method (RTPC, 1, Serialized)
                    {
                        If (OSDW ())
                        {
                            If ((Arg0 <= One))
                            {
                                \_SB.PCI0.RP05.RTBT = Arg0
                            }
                        }

                        Return (Zero)
                    }

                    Method (MUST, 1, Serialized)
                    {
                        Return (\_SB.PCI0.RP05.UPSB.MUST (Arg0))
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If (OSDW ())
                        {
                            PCED ()
                            \_SB.PCI0.RP05.CTBT ()
                        }
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                    }

                    Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                    {
                        If (OSDW ())
                        {
                            Local0 = Package (0x03)
                                {
                                    "power-save", 
                                    One, 
                                    Buffer (One)
                                    {
                                         0x00                                             // .
                                    }
                                }
                            DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                            Return (Local0)
                        }

                        Return (Zero)
                    }

                    Method (SXFP, 1, Serialized)
                    {
                        DBG2 ("SXFP", Arg0)
                        If ((Arg0 == Zero)){}
                    }
                }
            }

            Device (DSB1)
            {
                Name (_ADR, 0x00010000)  // _ADR: Address
                Name (_SUN, One)  // _SUN: Slot User Number
                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                Field (A1E0, ByteAcc, NoLock, Preserve)
                {
                    AVND,   32, 
                    BMIE,   3, 
                    Offset (0x18), 
                    PRIB,   8, 
                    SECB,   8, 
                    SUBB,   8, 
                    Offset (0x1E), 
                        ,   13, 
                    MABT,   1
                }

                OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
                Field (A1E1, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    Offset (0x08), 
                    Offset (0x0A), 
                        ,   5, 
                    TPEN,   1, 
                    Offset (0x0C), 
                    SSPD,   4, 
                        ,   16, 
                    LACR,   1, 
                    Offset (0x10), 
                        ,   4, 
                    LDIS,   1, 
                    LRTN,   1, 
                    Offset (0x12), 
                    CSPD,   4, 
                    CWDT,   6, 
                        ,   1, 
                    LTRN,   1, 
                        ,   1, 
                    LACT,   1, 
                    Offset (0x14), 
                    Offset (0x30), 
                    TSPD,   4
                }

                OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
                Field (A1E2, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    PSTA,   2
                }

                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                {
                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.SECB */
                }

                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (0x0F)
                }

                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                {
                    Return (Zero)
                }

                Device (UPS0)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    OperationRegion (ARE0, PCI_Config, Zero, 0x04)
                    Field (ARE0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   16
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        If (OSDW ())
                        {
                            Return (One)
                        }

                        Return (Zero)
                    }

                    Device (DSB0)
                    {
                        Name (_ADR, Zero)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1, 
                            Offset (0x3E), 
                                ,   6, 
                            SBRS,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB0.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }

                        Device (DEV0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            Method (_STA, 0, NotSerialized)  // _STA: Status
                            {
                                Return (0x0F)
                            }

                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                If (OSDW ())
                                {
                                    Return (One)
                                }

                                Return (Zero)
                            }
                        }
                    }

                    Device (DSB3)
                    {
                        Name (_ADR, 0x00030000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }

                        Device (UPS0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            OperationRegion (ARE0, PCI_Config, Zero, 0x04)
                            Field (ARE0, ByteAcc, NoLock, Preserve)
                            {
                                AVND,   16
                            }

                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                If (OSDW ())
                                {
                                    Return (One)
                                }

                                Return (Zero)
                            }

                            Device (DSB0)
                            {
                                Name (_ADR, Zero)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1, 
                                    Offset (0x3E), 
                                        ,   6, 
                                    SBRS,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB0.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }
                                }
                            }

                            Device (DSB3)
                            {
                                Name (_ADR, 0x00030000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB3.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB4)
                            {
                                Name (_ADR, 0x00040000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB4.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB5)
                            {
                                Name (_ADR, 0x00050000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB5.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }

                            Device (DSB6)
                            {
                                Name (_ADR, 0x00060000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB3.UPS0.DSB6.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }
                        }
                    }

                    Device (DSB4)
                    {
                        Name (_ADR, 0x00040000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }

                        Device (UPS0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            OperationRegion (ARE0, PCI_Config, Zero, 0x04)
                            Field (ARE0, ByteAcc, NoLock, Preserve)
                            {
                                AVND,   16
                            }

                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                If (OSDW ())
                                {
                                    Return (One)
                                }

                                Return (Zero)
                            }

                            Device (DSB0)
                            {
                                Name (_ADR, Zero)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1, 
                                    Offset (0x3E), 
                                        ,   6, 
                                    SBRS,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB0.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB3)
                            {
                                Name (_ADR, 0x00030000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB3.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB4)
                            {
                                Name (_ADR, 0x00040000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB4.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB5)
                            {
                                Name (_ADR, 0x00050000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB5.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }

                            Device (DSB6)
                            {
                                Name (_ADR, 0x00060000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB4.UPS0.DSB6.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }
                        }
                    }

                    Device (DSB5)
                    {
                        Name (_ADR, 0x00050000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB5.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }
                    }

                    Device (DSB6)
                    {
                        Name (_ADR, 0x00060000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB1.UPS0.DSB6.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }
                    }
                }
            }

            Device (DSB2)
            {
                Name (_ADR, 0x00020000)  // _ADR: Address
                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                Field (A1E0, ByteAcc, NoLock, Preserve)
                {
                    AVND,   32, 
                    BMIE,   3, 
                    Offset (0x18), 
                    PRIB,   8, 
                    SECB,   8, 
                    SUBB,   8, 
                    Offset (0x1E), 
                        ,   13, 
                    MABT,   1
                }

                OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
                Field (A1E1, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    Offset (0x08), 
                    Offset (0x0A), 
                        ,   5, 
                    TPEN,   1, 
                    Offset (0x0C), 
                    SSPD,   4, 
                        ,   16, 
                    LACR,   1, 
                    Offset (0x10), 
                        ,   4, 
                    LDIS,   1, 
                    LRTN,   1, 
                    Offset (0x12), 
                    CSPD,   4, 
                    CWDT,   6, 
                        ,   1, 
                    LTRN,   1, 
                        ,   1, 
                    LACT,   1, 
                    Offset (0x14), 
                    Offset (0x30), 
                    TSPD,   4
                }

                OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
                Field (A1E2, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    PSTA,   2
                }

                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                {
                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB2.SECB */
                }

                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (0x0F)
                }

                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                {
                    Return (Zero)
                }

                Name (IIP3, Zero)
                Name (PRSR, Zero)
                Name (PCIA, One)
                Method (PCEU, 0, Serialized)
                {
                    \_SB.PCI0.RP05.UPSB.DSB2.PRSR = Zero
                    If ((\_SB.PCI0.RP05.UPSB.DSB2.PSTA != Zero))
                    {
                        \_SB.PCI0.RP05.UPSB.DSB2.PRSR = One
                        \_SB.PCI0.RP05.UPSB.DSB2.PSTA = Zero
                    }

                    If ((\_SB.PCI0.RP05.UPSB.DSB2.LDIS == One))
                    {
                        \_SB.PCI0.RP05.UPSB.DSB2.PRSR = One
                        \_SB.PCI0.RP05.UPSB.DSB2.LDIS = Zero
                    }
                }

                Method (PCDA, 0, Serialized)
                {
                    If ((\_SB.PCI0.RP05.UPSB.DSB2.POFF () != Zero))
                    {
                        \_SB.PCI0.RP05.UPSB.DSB2.PCIA = Zero
                        \_SB.PCI0.RP05.UPSB.DSB2.PSTA = 0x03
                        \_SB.PCI0.RP05.UPSB.DSB2.LDIS = One
                        Local5 = (Timer + 0x00989680)
                        While ((Timer <= Local5))
                        {
                            If ((\_SB.PCI0.RP05.UPSB.DSB2.LACR == One))
                            {
                                If ((\_SB.PCI0.RP05.UPSB.DSB2.LACT == Zero))
                                {
                                    Break
                                }
                            }
                            ElseIf ((\_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND == 0xFFFFFFFF))
                            {
                                Break
                            }

                            Sleep (0x0A)
                        }

                        \_SB.PCI0.RP05.GXCI = Zero
                        \_SB.PCI0.RP05.UGIO ()
                    }
                    Else
                    {
                    }

                    \_SB.PCI0.RP05.UPSB.DSB2.IIP3 = One
                }

                Method (POFF, 0, Serialized)
                {
                    Return (!\_SB.PCI0.RP05.RUSB)
                }

                Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                {
                    If (OSDW ())
                    {
                        PCEU ()
                    }
                }

                Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                {
                    If (OSDW ())
                    {
                        PCDA ()
                    }
                }

                Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                {
                    If (OSDW ())
                    {
                        If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                        {
                            Local0 = Package (0x02)
                                {
                                    "PCIHotplugCapable", 
                                    Zero
                                }
                            DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                            Return (Local0)
                        }
                    }

                    Return (Zero)
                }

                Device (XHC2)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Name (SDPC, Zero)
                    OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    Method (PCED, 0, Serialized)
                    {
                        \_SB.PCI0.RP05.GXCI = One
                        If ((\_SB.PCI0.RP05.UGIO () != Zero))
                        {
                            \_SB.PCI0.RP05.UPSB.DSB2.PRSR = One
                        }

                        Local0 = Zero
                        Local1 = Zero
                        Local5 = (Timer + 0x00989680)
                        If ((\_SB.PCI0.RP05.UPSB.DSB2.PRSR != Zero))
                        {
                            Local5 = (Timer + 0x00989680)
                            While ((Timer <= Local5))
                            {
                                If ((\_SB.PCI0.RP05.UPSB.DSB2.LACR == Zero))
                                {
                                    If ((\_SB.PCI0.RP05.UPSB.DSB2.LTRN != One))
                                    {
                                        Break
                                    }
                                }
                                ElseIf (((\_SB.PCI0.RP05.UPSB.DSB2.LTRN != One) && (\_SB.PCI0.RP05.UPSB.DSB2.LACT == One)))
                                {
                                    Break
                                }

                                Sleep (0x0A)
                            }

                            Sleep (0x96)
                        }

                        \_SB.PCI0.RP05.UPSB.DSB2.PRSR = Zero
                        While ((Timer <= Local5))
                        {
                            If ((\_SB.PCI0.RP05.UPSB.DSB2.XHC2.AVND != 0xFFFFFFFF))
                            {
                                \_SB.PCI0.RP05.UPSB.DSB2.PCIA = One
                                Break
                            }

                            Sleep (0x0A)
                        }

                        \_SB.PCI0.RP05.UPSB.DSB2.IIP3 = Zero
                    }

                    Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                    {
                        Local0 = Package (0x06)
                            {
                                "USBBusNumber", 
                                Zero, 
                                "AAPL,xhci-clock-id", 
                                One, 
                                "UsbCompanionControllerPresent", 
                                One
                            }

                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }

                    Name (HS, Package (0x01)
                    {
                        "XHC"
                    })
                    Name (FS, Package (0x01)
                    {
                        "XHC"
                    })
                    Name (LS, Package (0x01)
                    {
                        "XHC"
                    })
                    Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
                    {
                        If (OSDW ())
                        {
                            Return (Package (0x02)
                            {
                                0x6D, 
                                0x04
                            })
                        }
                        Else
                        {
                            Return (Package (0x02)
                            {
                                0x6D, 
                                0x03
                            })
                        }
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If (OSDW ())
                        {
                            PCED ()
                        }
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                    }

                    Method (RTPC, 1, Serialized)
                    {
                        If (OSDW ())
                        {
                            If ((Arg0 <= One))
                            {
                                \_SB.PCI0.RP05.RUSB = Arg0
                            }
                        }

                        Return (Zero)
                    }

                    Method (MODU, 0, Serialized)
                    {
                        Return (\_SB.PCI0.RP05.UPSB.MDUV)
                    }

                    Device (RHUB)
                    {
                        Name (_ADR, Zero)  // _ADR: Address
                        Device (SSP1)
                        {
                            Name (_ADR, 0x03)  // _ADR: Address
                            Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                            {
                                0xFF, 
                                0x09, 
                                Zero, 
                                Zero
                            })
                            Name (_PLD, Package (0x01)  // _PLD: Physical Location of Device
                            {
                                ToPLD (
                                    PLD_Revision           = 0x1,
                                    PLD_IgnoreColor        = 0x1,
                                    PLD_Red                = 0x0,
                                    PLD_Green              = 0x0,
                                    PLD_Blue               = 0x0,
                                    PLD_Width              = 0x0,
                                    PLD_Height             = 0x0,
                                    PLD_UserVisible        = 0x1,
                                    PLD_Dock               = 0x0,
                                    PLD_Lid                = 0x0,
                                    PLD_Panel              = "UNKNOWN",
                                    PLD_VerticalPosition   = "UPPER",
                                    PLD_HorizontalPosition = "LEFT",
                                    PLD_Shape              = "UNKNOWN",
                                    PLD_GroupOrientation   = 0x0,
                                    PLD_GroupToken         = 0x0,
                                    PLD_GroupPosition      = 0x0,
                                    PLD_Bay                = 0x0,
                                    PLD_Ejectable          = 0x0,
                                    PLD_EjectRequired      = 0x0,
                                    PLD_CabinetNumber      = 0x0,
                                    PLD_CardCageNumber     = 0x0,
                                    PLD_Reference          = 0x0,
                                    PLD_Rotation           = 0x0,
                                    PLD_Order              = 0x0,
                                    PLD_VerticalOffset     = 0x0,
                                    PLD_HorizontalOffset   = 0x0)

                            })
                            Name (HS, Package (0x02)
                            {
                                "XHC", 
                                0x08
                            })
                            Name (FS, Package (0x02)
                            {
                                "XHC", 
                                0x08
                            })
                            Name (LS, Package (0x02)
                            {
                                "XHC", 
                                0x08
                            })
                            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                            {

                                Local0 = Package (0x0A)
                                    {
                                        "UsbCPortNumber", 
                                        0x03, 
                                        "UsbPowerSource", 
                                        0x03, 
                                        "kUSBWakePortCurrentLimit", 
                                        0x0BB8, 
                                        "kUSBSleepPortCurrentLimit", 
                                        0x0BB8, 
                                        "UsbCompanionPortPresent", 
                                        One
                                    }

                                DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                                Return (Local0)
                            }
                        }

                        Device (SSP2)
                        {
                            Name (_ADR, 0x04)  // _ADR: Address
                            Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                            {
                                0xFF, 
                                0x09, 
                                Zero, 
                                Zero
                            })
                            Name (_PLD, Package (0x01)  // _PLD: Physical Location of Device
                            {
                                ToPLD (
                                    PLD_Revision           = 0x1,
                                    PLD_IgnoreColor        = 0x1,
                                    PLD_Red                = 0x0,
                                    PLD_Green              = 0x0,
                                    PLD_Blue               = 0x0,
                                    PLD_Width              = 0x0,
                                    PLD_Height             = 0x0,
                                    PLD_UserVisible        = 0x1,
                                    PLD_Dock               = 0x0,
                                    PLD_Lid                = 0x0,
                                    PLD_Panel              = "UNKNOWN",
                                    PLD_VerticalPosition   = "UPPER",
                                    PLD_HorizontalPosition = "LEFT",
                                    PLD_Shape              = "UNKNOWN",
                                    PLD_GroupOrientation   = 0x0,
                                    PLD_GroupToken         = 0x0,
                                    PLD_GroupPosition      = 0x0,
                                    PLD_Bay                = 0x0,
                                    PLD_Ejectable          = 0x0,
                                    PLD_EjectRequired      = 0x0,
                                    PLD_CabinetNumber      = 0x0,
                                    PLD_CardCageNumber     = 0x0,
                                    PLD_Reference          = 0x0,
                                    PLD_Rotation           = 0x0,
                                    PLD_Order              = 0x0,
                                    PLD_VerticalOffset     = 0x0,
                                    PLD_HorizontalOffset   = 0x0)

                            })
                            Name (HS, Package (0x02)
                            {
                                "XHC", 
                                0x0D
                            })
                            Name (FS, Package (0x02)
                            {
                                "XHC", 
                                0x0D
                            })
                            Name (LS, Package (0x02)
                            {
                                "XHC", 
                                0x0D
                            })
                            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                            {
                                Local0 = Package (0x0A)
                                    {
                                        "UsbCPortNumber", 
                                        0x04, 
                                        "UsbPowerSource", 
                                        0x04, 
                                        "kUSBWakePortCurrentLimit", 
                                        0x0BB8, 
                                        "kUSBSleepPortCurrentLimit", 
                                        0x0BB8, 
                                        "UsbCompanionPortPresent", 
                                        One
                                    }

                                DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                                Return (Local0)
                            }
                        }
                    }
                }
            }

            Device (DSB4)
            {
                Name (_ADR, 0x00040000)  // _ADR: Address
                Name (_SUN, 0x02)  // _SUN: Slot User Number
                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                Field (A1E0, ByteAcc, NoLock, Preserve)
                {
                    AVND,   32, 
                    BMIE,   3, 
                    Offset (0x18), 
                    PRIB,   8, 
                    SECB,   8, 
                    SUBB,   8, 
                    Offset (0x1E), 
                        ,   13, 
                    MABT,   1
                }

                OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
                Field (A1E1, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    Offset (0x08), 
                    Offset (0x0A), 
                        ,   5, 
                    TPEN,   1, 
                    Offset (0x0C), 
                    SSPD,   4, 
                        ,   16, 
                    LACR,   1, 
                    Offset (0x10), 
                        ,   4, 
                    LDIS,   1, 
                    LRTN,   1, 
                    Offset (0x12), 
                    CSPD,   4, 
                    CWDT,   6, 
                        ,   1, 
                    LTRN,   1, 
                        ,   1, 
                    LACT,   1, 
                    Offset (0x14), 
                    Offset (0x30), 
                    TSPD,   4
                }

                OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
                Field (A1E2, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    PSTA,   2
                }

                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                {
                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.SECB */
                }

                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (0x0F)
                }

                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                {
                    Return (Zero)
                }

                Device (UPS0)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    OperationRegion (ARE0, PCI_Config, Zero, 0x04)
                    Field (ARE0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   16
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        If (OSDW ())
                        {
                            Return (One)
                        }

                        Return (Zero)
                    }

                    Device (DSB0)
                    {
                        Name (_ADR, Zero)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1, 
                            Offset (0x3E), 
                                ,   6, 
                            SBRS,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB0.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }

                        Device (DEV0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            Method (_STA, 0, NotSerialized)  // _STA: Status
                            {
                                Return (0x0F)
                            }

                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                If (OSDW ())
                                {
                                    Return (One)
                                }

                                Return (Zero)
                            }
                        }
                    }

                    Device (DSB3)
                    {
                        Name (_ADR, 0x00030000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }

                        Device (UPS0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            OperationRegion (ARE0, PCI_Config, Zero, 0x04)
                            Field (ARE0, ByteAcc, NoLock, Preserve)
                            {
                                AVND,   16
                            }

                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                If (OSDW ())
                                {
                                    Return (One)
                                }

                                Return (Zero)
                            }

                            Device (DSB0)
                            {
                                Name (_ADR, Zero)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1, 
                                    Offset (0x3E), 
                                        ,   6, 
                                    SBRS,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB0.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }
                                }
                            }

                            Device (DSB3)
                            {
                                Name (_ADR, 0x00030000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB3.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB4)
                            {
                                Name (_ADR, 0x00040000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB4.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB5)
                            {
                                Name (_ADR, 0x00050000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB5.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }

                            Device (DSB6)
                            {
                                Name (_ADR, 0x00060000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB3.UPS0.DSB6.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }
                        }
                    }

                    Device (DSB4)
                    {
                        Name (_ADR, 0x00040000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }

                        Device (UPS0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            OperationRegion (ARE0, PCI_Config, Zero, 0x04)
                            Field (ARE0, ByteAcc, NoLock, Preserve)
                            {
                                AVND,   16
                            }

                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                If (OSDW ())
                                {
                                    Return (One)
                                }

                                Return (Zero)
                            }

                            Device (DSB0)
                            {
                                Name (_ADR, Zero)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1, 
                                    Offset (0x3E), 
                                        ,   6, 
                                    SBRS,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB0.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB3)
                            {
                                Name (_ADR, 0x00030000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB3.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB4)
                            {
                                Name (_ADR, 0x00040000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB4.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }

                                Device (DEV0)
                                {
                                    Name (_ADR, Zero)  // _ADR: Address
                                    Method (_STA, 0, NotSerialized)  // _STA: Status
                                    {
                                        Return (0x0F)
                                    }

                                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                    {
                                        If (OSDW ())
                                        {
                                            Return (One)
                                        }

                                        Return (Zero)
                                    }
                                }
                            }

                            Device (DSB5)
                            {
                                Name (_ADR, 0x00050000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB5.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }

                            Device (DSB6)
                            {
                                Name (_ADR, 0x00060000)  // _ADR: Address
                                OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                                Field (A1E0, ByteAcc, NoLock, Preserve)
                                {
                                    AVND,   32, 
                                    BMIE,   3, 
                                    Offset (0x18), 
                                    PRIB,   8, 
                                    SECB,   8, 
                                    SUBB,   8, 
                                    Offset (0x1E), 
                                        ,   13, 
                                    MABT,   1
                                }

                                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                                {
                                    Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB4.UPS0.DSB6.SECB */
                                }

                                Method (_STA, 0, NotSerialized)  // _STA: Status
                                {
                                    Return (0x0F)
                                }

                                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                                {
                                    If (OSDW ())
                                    {
                                        Return (One)
                                    }

                                    Return (Zero)
                                }
                            }
                        }
                    }

                    Device (DSB5)
                    {
                        Name (_ADR, 0x00050000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB5.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }
                    }

                    Device (DSB6)
                    {
                        Name (_ADR, 0x00060000)  // _ADR: Address
                        OperationRegion (A1E0, PCI_Config, Zero, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                        {
                            Return (SECB) /* \_SB_.PCI0.RP05.UPSB.DSB4.UPS0.DSB6.SECB */
                        }

                        Method (_STA, 0, NotSerialized)  // _STA: Status
                        {
                            Return (0x0F)
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            If (OSDW ())
                            {
                                Return (One)
                            }

                            Return (Zero)
                        }
                    }
                }
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (OSDW ())
                {
                    If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                    {
                        Local0 = Package (0x02)
                            {
                                "PCI-Thunderbolt", 
                                One
                            }
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                }

                Return (Zero)
            }
        }
    }
}

